//------------------------------------------------------------------------------
//  (c) Copyright 2013-2018 Xilinx, Inc. All rights reserved.
//
//  This file contains confidential and proprietary information
//  of Xilinx, Inc. and is protected under U.S. and
//  international copyright and other intellectual property
//  laws.
//
//  DISCLAIMER
//  This disclaimer is not a license and does not grant any
//  rights to the materials distributed herewith. Except as
//  otherwise provided in a valid license issued to you by
//  Xilinx, and to the maximum extent permitted by applicable
//  law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
//  WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
//  AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
//  BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
//  INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
//  (2) Xilinx shall not be liable (whether in contract or tort,
//  including negligence, or under any other theory of
//  liability) for any loss or damage of any kind or nature
//  related to, arising under or in connection with these
//  materials, including for any direct, or any indirect,
//  special, incidental, or consequential loss or damage
//  (including loss of data, profits, goodwill, or any type of
//  loss or damage suffered as a result of any action brought
//  by a third party) even if such damage or loss was
//  reasonably foreseeable or Xilinx had been advised of the
//  possibility of the same.
//
//  CRITICAL APPLICATIONS
//  Xilinx products are not designed or intended to be fail-
//  safe, or for use in any application requiring fail-safe
//  performance, such as life-support or safety devices or
//  systems, Class III medical devices, nuclear facilities,
//  applications related to the deployment of airbags, or any
//  other applications that could lead to death, personal
//  injury, or severe property or environmental damage
//  (individually and collectively, "Critical
//  Applications"). Customer assumes the sole risk and
//  liability of any use of Xilinx products in Critical
//  Applications, subject only to applicable laws and
//  regulations governing limitations on product liability.
//
//  THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
//  PART OF THIS FILE AT ALL TIMES.
//------------------------------------------------------------------------------

// ***************************
// * DO NOT MODIFY THIS FILE *
// ***************************



`timescale 1ps/1ps
module gtwizard_ultrascale_2_gthe4_channel_wrapper #(
  parameter MASTER_EN                                     = 0,
  parameter NUM_CHANNELS                                  = 1
)(
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CDRSTEPDIR,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CDRSTEPSQ,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CDRSTEPSX,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CFGRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CLKRSVD0,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CLKRSVD1,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CPLLFREQLOCK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CPLLLOCKDETCLK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CPLLLOCKEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CPLLPD,
  input                  [(NUM_CHANNELS*3)-1:0] GTHE4_CHANNEL_CPLLREFCLKSEL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CPLLRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_DMONFIFORESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_DMONITORCLK,
  input                 [(NUM_CHANNELS*10)-1:0] GTHE4_CHANNEL_DRPADDR,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_DRPCLK,
  input                 [(NUM_CHANNELS*16)-1:0] GTHE4_CHANNEL_DRPDI,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_DRPEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_DRPRST,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_DRPWE,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_EYESCANRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_EYESCANTRIGGER,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_FREQOS,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTGREFCLK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTHRXN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTHRXP,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTNORTHREFCLK0,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTNORTHREFCLK1,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTREFCLK0,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTREFCLK1,
  input                 [(NUM_CHANNELS*16)-1:0] GTHE4_CHANNEL_GTRSVD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTRXRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTRXRESETSEL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTSOUTHREFCLK0,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTSOUTHREFCLK1,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTTXRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTTXRESETSEL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_INCPCTRL,
  input                  [(NUM_CHANNELS*3)-1:0] GTHE4_CHANNEL_LOOPBACK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_PCIEEQRXEQADAPTDONE,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_PCIERSTIDLE,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_PCIERSTTXSYNCSTART,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_PCIEUSERRATEDONE,
  input                 [(NUM_CHANNELS*16)-1:0] GTHE4_CHANNEL_PCSRSVDIN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_QPLL0CLK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_QPLL0FREQLOCK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_QPLL0REFCLK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_QPLL1CLK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_QPLL1FREQLOCK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_QPLL1REFCLK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RESETOVRD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RX8B10BEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXAFECFOKEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXBUFRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCDRFREQRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCDRHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCDROVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCDRRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCHBONDEN,
  input                  [(NUM_CHANNELS*5)-1:0] GTHE4_CHANNEL_RXCHBONDI,
  input                  [(NUM_CHANNELS*3)-1:0] GTHE4_CHANNEL_RXCHBONDLEVEL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCHBONDMASTER,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCHBONDSLAVE,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCKCALRESET,
  input                  [(NUM_CHANNELS*7)-1:0] GTHE4_CHANNEL_RXCKCALSTART,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCOMMADETEN,
  input                  [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_RXDFEAGCCTRL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFEAGCHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFEAGCOVRDEN,
  input                  [(NUM_CHANNELS*4)-1:0] GTHE4_CHANNEL_RXDFECFOKFCNUM,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFECFOKFEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFECFOKFPULSE,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFECFOKHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFECFOKOVREN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFEKHHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFEKHOVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFELFHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFELFOVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFELPMRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP10HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP10OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP11HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP11OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP12HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP12OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP13HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP13OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP14HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP14OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP15HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP15OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP2HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP2OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP3HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP3OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP4HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP4OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP5HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP5OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP6HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP6OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP7HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP7OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP8HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP8OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP9HOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFETAP9OVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFEUTHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFEUTOVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFEVPHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFEVPOVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDFEXYDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDLYBYPASS,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDLYEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDLYOVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDLYSRESET,
  input                  [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_RXELECIDLEMODE,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXEQTRAINING,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXGEARBOXSLIP,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXLATCLK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXLPMEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXLPMGCHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXLPMGCOVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXLPMHFHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXLPMHFOVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXLPMLFHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXLPMLFKLOVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXLPMOSHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXLPMOSOVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXMCOMMAALIGNEN,
  input                  [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_RXMONITORSEL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXOOBRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXOSCALRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXOSHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXOSOVRDEN,
  input                  [(NUM_CHANNELS*3)-1:0] GTHE4_CHANNEL_RXOUTCLKSEL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPCOMMAALIGNEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPCSRESET,
  input                  [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_RXPD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPHALIGN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPHALIGNEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPHDLYPD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPHDLYRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPHOVRDEN,
  input                  [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_RXPLLCLKSEL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPMARESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPOLARITY,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPRBSCNTRESET,
  input                  [(NUM_CHANNELS*4)-1:0] GTHE4_CHANNEL_RXPRBSSEL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPROGDIVRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXQPIEN,
  input                  [(NUM_CHANNELS*3)-1:0] GTHE4_CHANNEL_RXRATE,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXRATEMODE,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXSLIDE,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXSLIPOUTCLK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXSLIPPMA,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXSYNCALLIN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXSYNCIN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXSYNCMODE,
  input                  [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_RXSYSCLKSEL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXTERMINATION,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXUSERRDY,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXUSRCLK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXUSRCLK2,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_SIGVALIDCLK,
  input                 [(NUM_CHANNELS*20)-1:0] GTHE4_CHANNEL_TSTIN,
  input                  [(NUM_CHANNELS*8)-1:0] GTHE4_CHANNEL_TX8B10BBYPASS,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TX8B10BEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXCOMINIT,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXCOMSAS,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXCOMWAKE,
  input                 [(NUM_CHANNELS*16)-1:0] GTHE4_CHANNEL_TXCTRL0,
  input                 [(NUM_CHANNELS*16)-1:0] GTHE4_CHANNEL_TXCTRL1,
  input                  [(NUM_CHANNELS*8)-1:0] GTHE4_CHANNEL_TXCTRL2,
  input                [(NUM_CHANNELS*128)-1:0] GTHE4_CHANNEL_TXDATA,
  input                  [(NUM_CHANNELS*8)-1:0] GTHE4_CHANNEL_TXDATAEXTENDRSVD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXDCCFORCESTART,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXDCCRESET,
  input                  [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_TXDEEMPH,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXDETECTRX,
  input                  [(NUM_CHANNELS*5)-1:0] GTHE4_CHANNEL_TXDIFFCTRL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXDLYBYPASS,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXDLYEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXDLYHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXDLYOVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXDLYSRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXDLYUPDOWN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXELECIDLE,
  input                  [(NUM_CHANNELS*6)-1:0] GTHE4_CHANNEL_TXHEADER,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXINHIBIT,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXLATCLK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXLFPSTRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXLFPSU2LPEXIT,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXLFPSU3WAKE,
  input                  [(NUM_CHANNELS*7)-1:0] GTHE4_CHANNEL_TXMAINCURSOR,
  input                  [(NUM_CHANNELS*3)-1:0] GTHE4_CHANNEL_TXMARGIN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXMUXDCDEXHOLD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXMUXDCDORWREN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXONESZEROS,
  input                  [(NUM_CHANNELS*3)-1:0] GTHE4_CHANNEL_TXOUTCLKSEL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPCSRESET,
  input                  [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_TXPD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPDELECIDLEMODE,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPHALIGN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPHALIGNEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPHDLYPD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPHDLYRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPHDLYTSTCLK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPHINIT,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPHOVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPIPPMEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPIPPMOVRDEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPIPPMPD,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPIPPMSEL,
  input                  [(NUM_CHANNELS*5)-1:0] GTHE4_CHANNEL_TXPIPPMSTEPSIZE,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPISOPD,
  input                  [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_TXPLLCLKSEL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPMARESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPOLARITY,
  input                  [(NUM_CHANNELS*5)-1:0] GTHE4_CHANNEL_TXPOSTCURSOR,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPRBSFORCEERR,
  input                  [(NUM_CHANNELS*4)-1:0] GTHE4_CHANNEL_TXPRBSSEL,
  input                  [(NUM_CHANNELS*5)-1:0] GTHE4_CHANNEL_TXPRECURSOR,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPROGDIVRESET,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXQPIBIASEN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXQPIWEAKPUP,
  input                  [(NUM_CHANNELS*3)-1:0] GTHE4_CHANNEL_TXRATE,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXRATEMODE,
  input                  [(NUM_CHANNELS*7)-1:0] GTHE4_CHANNEL_TXSEQUENCE,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXSWING,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXSYNCALLIN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXSYNCIN,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXSYNCMODE,
  input                  [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_TXSYSCLKSEL,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXUSERRDY,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXUSRCLK,
  input                  [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXUSRCLK2,

  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_BUFGTCE,
  output                 [(NUM_CHANNELS*3)-1:0] GTHE4_CHANNEL_BUFGTCEMASK,
  output                 [(NUM_CHANNELS*9)-1:0] GTHE4_CHANNEL_BUFGTDIV,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_BUFGTRESET,
  output                 [(NUM_CHANNELS*3)-1:0] GTHE4_CHANNEL_BUFGTRSTMASK,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CPLLFBCLKLOST,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CPLLLOCK,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_CPLLREFCLKLOST,
  output                [(NUM_CHANNELS*16)-1:0] GTHE4_CHANNEL_DMONITOROUT,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_DMONITOROUTCLK,
  output                [(NUM_CHANNELS*16)-1:0] GTHE4_CHANNEL_DRPDO,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_DRPRDY,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_EYESCANDATAERROR,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTHTXN,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTHTXP,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTPOWERGOOD,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_GTREFCLKMONITOR,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_PCIERATEGEN3,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_PCIERATEIDLE,
  output                 [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_PCIERATEQPLLPD,
  output                 [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_PCIERATEQPLLRESET,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_PCIESYNCTXSYNCDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_PCIEUSERGEN3RDY,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_PCIEUSERPHYSTATUSRST,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_PCIEUSERRATESTART,
  output                [(NUM_CHANNELS*16)-1:0] GTHE4_CHANNEL_PCSRSVDOUT,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_PHYSTATUS,
  output                [(NUM_CHANNELS*16)-1:0] GTHE4_CHANNEL_PINRSRVDAS,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_POWERPRESENT,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RESETEXCEPTION,
  output                 [(NUM_CHANNELS*3)-1:0] GTHE4_CHANNEL_RXBUFSTATUS,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXBYTEISALIGNED,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXBYTEREALIGN,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCDRLOCK,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCDRPHDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCHANBONDSEQ,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCHANISALIGNED,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCHANREALIGN,
  output                 [(NUM_CHANNELS*5)-1:0] GTHE4_CHANNEL_RXCHBONDO,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCKCALDONE,
  output                 [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_RXCLKCORCNT,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCOMINITDET,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCOMMADET,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCOMSASDET,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXCOMWAKEDET,
  output                [(NUM_CHANNELS*16)-1:0] GTHE4_CHANNEL_RXCTRL0,
  output                [(NUM_CHANNELS*16)-1:0] GTHE4_CHANNEL_RXCTRL1,
  output                 [(NUM_CHANNELS*8)-1:0] GTHE4_CHANNEL_RXCTRL2,
  output                 [(NUM_CHANNELS*8)-1:0] GTHE4_CHANNEL_RXCTRL3,
  output               [(NUM_CHANNELS*128)-1:0] GTHE4_CHANNEL_RXDATA,
  output                 [(NUM_CHANNELS*8)-1:0] GTHE4_CHANNEL_RXDATAEXTENDRSVD,
  output                 [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_RXDATAVALID,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXDLYSRESETDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXELECIDLE,
  output                 [(NUM_CHANNELS*6)-1:0] GTHE4_CHANNEL_RXHEADER,
  output                 [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_RXHEADERVALID,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXLFPSTRESETDET,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXLFPSU2LPEXITDET,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXLFPSU3WAKEDET,
  output                 [(NUM_CHANNELS*8)-1:0] GTHE4_CHANNEL_RXMONITOROUT,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXOSINTDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXOSINTSTARTED,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXOSINTSTROBEDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXOSINTSTROBESTARTED,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXOUTCLK,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXOUTCLKFABRIC,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXOUTCLKPCS,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPHALIGNDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPHALIGNERR,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPMARESETDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPRBSERR,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPRBSLOCKED,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXPRGDIVRESETDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXQPISENN,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXQPISENP,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXRATEDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXRECCLKOUT,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXRESETDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXSLIDERDY,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXSLIPDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXSLIPOUTCLKRDY,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXSLIPPMARDY,
  output                 [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_RXSTARTOFSEQ,
  output                 [(NUM_CHANNELS*3)-1:0] GTHE4_CHANNEL_RXSTATUS,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXSYNCDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXSYNCOUT,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_RXVALID,
  output                 [(NUM_CHANNELS*2)-1:0] GTHE4_CHANNEL_TXBUFSTATUS,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXCOMFINISH,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXDCCDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXDLYSRESETDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXOUTCLK,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXOUTCLKFABRIC,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXOUTCLKPCS,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPHALIGNDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPHINITDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPMARESETDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXPRGDIVRESETDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXQPISENN,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXQPISENP,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXRATEDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXRESETDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXSYNCDONE,
  output                 [(NUM_CHANNELS*1)-1:0] GTHE4_CHANNEL_TXSYNCOUT
);



gtwizard_ultrascale_v1_7_7_gthe4_channel #(
  .GTHE4_CHANNEL_ACJTAG_DEBUG_MODE              (1'b0),
  .GTHE4_CHANNEL_ACJTAG_MODE                    (1'b0),
  .GTHE4_CHANNEL_ACJTAG_RESET                   (1'b0),
  .GTHE4_CHANNEL_ADAPT_CFG0                     (16'b0001000000000000),
  .GTHE4_CHANNEL_ADAPT_CFG1                     (16'b1100100000000000),
  .GTHE4_CHANNEL_ADAPT_CFG2                     (16'b0000000000000000),
  .GTHE4_CHANNEL_ALIGN_COMMA_DOUBLE             ("FALSE"),
  .GTHE4_CHANNEL_ALIGN_COMMA_ENABLE             (10'b1111111111),
  .GTHE4_CHANNEL_ALIGN_COMMA_WORD               (2),
  .GTHE4_CHANNEL_ALIGN_MCOMMA_DET               ("TRUE"),
  .GTHE4_CHANNEL_ALIGN_MCOMMA_VALUE             (10'b1010000011),
  .GTHE4_CHANNEL_ALIGN_PCOMMA_DET               ("TRUE"),
  .GTHE4_CHANNEL_ALIGN_PCOMMA_VALUE             (10'b0101111100),
  .GTHE4_CHANNEL_A_RXOSCALRESET                 (1'b0),
  .GTHE4_CHANNEL_A_RXPROGDIVRESET               (1'b0),
  .GTHE4_CHANNEL_A_RXTERMINATION                (1'b1),
  .GTHE4_CHANNEL_A_TXDIFFCTRL                   (5'b01100),
  .GTHE4_CHANNEL_A_TXPROGDIVRESET               (1'b0),
  .GTHE4_CHANNEL_CAPBYPASS_FORCE                (1'b0),
  .GTHE4_CHANNEL_CBCC_DATA_SOURCE_SEL           ("DECODED"),
  .GTHE4_CHANNEL_CDRSTEPDIR_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_CDRSTEPDIR_VAL                 (1'b0),
  .GTHE4_CHANNEL_CDRSTEPSQ_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_CDRSTEPSQ_VAL                  (1'b0),
  .GTHE4_CHANNEL_CDRSTEPSX_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_CDRSTEPSX_VAL                  (1'b0),
  .GTHE4_CHANNEL_CDR_SWAP_MODE_EN               (1'b0),
  .GTHE4_CHANNEL_CFGRESET_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_CFGRESET_VAL                   (1'b0),
  .GTHE4_CHANNEL_CFOK_PWRSVE_EN                 (1'b1),
  .GTHE4_CHANNEL_CHAN_BOND_KEEP_ALIGN           ("FALSE"),
  .GTHE4_CHANNEL_CHAN_BOND_MAX_SKEW             (1),
  .GTHE4_CHANNEL_CHAN_BOND_SEQ_1_1              (10'b0000000000),
  .GTHE4_CHANNEL_CHAN_BOND_SEQ_1_2              (10'b0000000000),
  .GTHE4_CHANNEL_CHAN_BOND_SEQ_1_3              (10'b0000000000),
  .GTHE4_CHANNEL_CHAN_BOND_SEQ_1_4              (10'b0000000000),
  .GTHE4_CHANNEL_CHAN_BOND_SEQ_1_ENABLE         (4'b1111),
  .GTHE4_CHANNEL_CHAN_BOND_SEQ_2_1              (10'b0000000000),
  .GTHE4_CHANNEL_CHAN_BOND_SEQ_2_2              (10'b0000000000),
  .GTHE4_CHANNEL_CHAN_BOND_SEQ_2_3              (10'b0000000000),
  .GTHE4_CHANNEL_CHAN_BOND_SEQ_2_4              (10'b0000000000),
  .GTHE4_CHANNEL_CHAN_BOND_SEQ_2_ENABLE         (4'b1111),
  .GTHE4_CHANNEL_CHAN_BOND_SEQ_2_USE            ("FALSE"),
  .GTHE4_CHANNEL_CHAN_BOND_SEQ_LEN              (1),
  .GTHE4_CHANNEL_CH_HSPMUX                      (16'b0011110000111100),
  .GTHE4_CHANNEL_CKCAL1_CFG_0                   (16'b1100000011000000),
  .GTHE4_CHANNEL_CKCAL1_CFG_1                   (16'b0101000011000000),
  .GTHE4_CHANNEL_CKCAL1_CFG_2                   (16'b0000000000001010),
  .GTHE4_CHANNEL_CKCAL1_CFG_3                   (16'b0000000000000000),
  .GTHE4_CHANNEL_CKCAL2_CFG_0                   (16'b1100000011000000),
  .GTHE4_CHANNEL_CKCAL2_CFG_1                   (16'b1000000011000000),
  .GTHE4_CHANNEL_CKCAL2_CFG_2                   (16'b0000000000000000),
  .GTHE4_CHANNEL_CKCAL2_CFG_3                   (16'b0000000000000000),
  .GTHE4_CHANNEL_CKCAL2_CFG_4                   (16'b0000000000000000),
  .GTHE4_CHANNEL_CKCAL_RSVD0                    (16'b0000000000000000),
  .GTHE4_CHANNEL_CKCAL_RSVD1                    (16'b0000010000000000),
  .GTHE4_CHANNEL_CLKRSVD0_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_CLKRSVD0_VAL                   (1'b0),
  .GTHE4_CHANNEL_CLKRSVD1_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_CLKRSVD1_VAL                   (1'b0),
  .GTHE4_CHANNEL_CLK_CORRECT_USE                ("FALSE"),
  .GTHE4_CHANNEL_CLK_COR_KEEP_IDLE              ("FALSE"),
  .GTHE4_CHANNEL_CLK_COR_MAX_LAT                (20),
  .GTHE4_CHANNEL_CLK_COR_MIN_LAT                (18),
  .GTHE4_CHANNEL_CLK_COR_PRECEDENCE             ("TRUE"),
  .GTHE4_CHANNEL_CLK_COR_REPEAT_WAIT            (0),
  .GTHE4_CHANNEL_CLK_COR_SEQ_1_1                (10'b0100000000),
  .GTHE4_CHANNEL_CLK_COR_SEQ_1_2                (10'b0100000000),
  .GTHE4_CHANNEL_CLK_COR_SEQ_1_3                (10'b0100000000),
  .GTHE4_CHANNEL_CLK_COR_SEQ_1_4                (10'b0100000000),
  .GTHE4_CHANNEL_CLK_COR_SEQ_1_ENABLE           (4'b1111),
  .GTHE4_CHANNEL_CLK_COR_SEQ_2_1                (10'b0100000000),
  .GTHE4_CHANNEL_CLK_COR_SEQ_2_2                (10'b0100000000),
  .GTHE4_CHANNEL_CLK_COR_SEQ_2_3                (10'b0100000000),
  .GTHE4_CHANNEL_CLK_COR_SEQ_2_4                (10'b0100000000),
  .GTHE4_CHANNEL_CLK_COR_SEQ_2_ENABLE           (4'b1111),
  .GTHE4_CHANNEL_CLK_COR_SEQ_2_USE              ("FALSE"),
  .GTHE4_CHANNEL_CLK_COR_SEQ_LEN                (1),
  .GTHE4_CHANNEL_CPLLFREQLOCK_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_CPLLFREQLOCK_VAL               (1'b0),
  .GTHE4_CHANNEL_CPLLLOCKDETCLK_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_CPLLLOCKDETCLK_VAL             (1'b0),
  .GTHE4_CHANNEL_CPLLLOCKEN_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_CPLLLOCKEN_VAL                 (1'b1),
  .GTHE4_CHANNEL_CPLLPD_TIE_EN                  (1'b0),
  .GTHE4_CHANNEL_CPLLPD_VAL                     (1'b0),
  .GTHE4_CHANNEL_CPLLREFCLKSEL_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_CPLLREFCLKSEL_VAL              (3'b001),
  .GTHE4_CHANNEL_CPLLRESET_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_CPLLRESET_VAL                  (1'b0),
  .GTHE4_CHANNEL_CPLL_CFG0                      (16'b0000000111111010),
  .GTHE4_CHANNEL_CPLL_CFG1                      (16'b0000000000100011),
  .GTHE4_CHANNEL_CPLL_CFG2                      (16'b0000000000000010),
  .GTHE4_CHANNEL_CPLL_CFG3                      (16'b0000000000000000),
  .GTHE4_CHANNEL_CPLL_FBDIV                     (5),
  .GTHE4_CHANNEL_CPLL_FBDIV_45                  (4),
  .GTHE4_CHANNEL_CPLL_INIT_CFG0                 (16'b0000001010110010),
  .GTHE4_CHANNEL_CPLL_LOCK_CFG                  (16'b0000000111101000),
  .GTHE4_CHANNEL_CPLL_REFCLK_DIV                (1),
  .GTHE4_CHANNEL_CTLE3_OCAP_EXT_CTRL            (3'b000),
  .GTHE4_CHANNEL_CTLE3_OCAP_EXT_EN              (1'b0),
  .GTHE4_CHANNEL_DDI_CTRL                       (2'b00),
  .GTHE4_CHANNEL_DDI_REALIGN_WAIT               (15),
  .GTHE4_CHANNEL_DEC_MCOMMA_DETECT              ("TRUE"),
  .GTHE4_CHANNEL_DEC_PCOMMA_DETECT              ("TRUE"),
  .GTHE4_CHANNEL_DEC_VALID_COMMA_ONLY           ("FALSE"),
  .GTHE4_CHANNEL_DELAY_ELEC                     (1'b0),
  .GTHE4_CHANNEL_DMONFIFORESET_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_DMONFIFORESET_VAL              (1'b0),
  .GTHE4_CHANNEL_DMONITORCLK_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_DMONITORCLK_VAL                (1'b0),
  .GTHE4_CHANNEL_DMONITOR_CFG0                  (10'b0000000000),
  .GTHE4_CHANNEL_DMONITOR_CFG1                  (8'b00000000),
  .GTHE4_CHANNEL_DRPADDR_TIE_EN                 (1'b0),
  .GTHE4_CHANNEL_DRPADDR_VAL                    (10'b0000000000),
  .GTHE4_CHANNEL_DRPCLK_TIE_EN                  (1'b0),
  .GTHE4_CHANNEL_DRPCLK_VAL                     (1'b0),
  .GTHE4_CHANNEL_DRPDI_TIE_EN                   (1'b0),
  .GTHE4_CHANNEL_DRPDI_VAL                      (16'b0000000000000000),
  .GTHE4_CHANNEL_DRPEN_TIE_EN                   (1'b0),
  .GTHE4_CHANNEL_DRPEN_VAL                      (1'b0),
  .GTHE4_CHANNEL_DRPRST_TIE_EN                  (1'b0),
  .GTHE4_CHANNEL_DRPRST_VAL                     (1'b0),
  .GTHE4_CHANNEL_DRPWE_TIE_EN                   (1'b0),
  .GTHE4_CHANNEL_DRPWE_VAL                      (1'b0),
  .GTHE4_CHANNEL_ES_CLK_PHASE_SEL               (1'b0),
  .GTHE4_CHANNEL_ES_CONTROL                     (6'b000000),
  .GTHE4_CHANNEL_ES_ERRDET_EN                   ("FALSE"),
  .GTHE4_CHANNEL_ES_EYE_SCAN_EN                 ("FALSE"),
  .GTHE4_CHANNEL_ES_HORZ_OFFSET                 (12'b000000000000),
  .GTHE4_CHANNEL_ES_PRESCALE                    (5'b00000),
  .GTHE4_CHANNEL_ES_QUALIFIER0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUALIFIER1                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUALIFIER2                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUALIFIER3                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUALIFIER4                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUALIFIER5                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUALIFIER6                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUALIFIER7                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUALIFIER8                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUALIFIER9                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUAL_MASK0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUAL_MASK1                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUAL_MASK2                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUAL_MASK3                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUAL_MASK4                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUAL_MASK5                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUAL_MASK6                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUAL_MASK7                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUAL_MASK8                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_QUAL_MASK9                  (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_SDATA_MASK0                 (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_SDATA_MASK1                 (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_SDATA_MASK2                 (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_SDATA_MASK3                 (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_SDATA_MASK4                 (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_SDATA_MASK5                 (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_SDATA_MASK6                 (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_SDATA_MASK7                 (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_SDATA_MASK8                 (16'b0000000000000000),
  .GTHE4_CHANNEL_ES_SDATA_MASK9                 (16'b0000000000000000),
  .GTHE4_CHANNEL_EYESCANRESET_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_EYESCANRESET_VAL               (1'b0),
  .GTHE4_CHANNEL_EYESCANTRIGGER_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_EYESCANTRIGGER_VAL             (1'b0),
  .GTHE4_CHANNEL_EYE_SCAN_SWAP_EN               (1'b0),
  .GTHE4_CHANNEL_FREQOS_TIE_EN                  (1'b0),
  .GTHE4_CHANNEL_FREQOS_VAL                     (1'b0),
  .GTHE4_CHANNEL_FTS_DESKEW_SEQ_ENABLE          (4'b1111),
  .GTHE4_CHANNEL_FTS_LANE_DESKEW_CFG            (4'b1111),
  .GTHE4_CHANNEL_FTS_LANE_DESKEW_EN             ("FALSE"),
  .GTHE4_CHANNEL_GEARBOX_MODE                   (5'b00000),
  .GTHE4_CHANNEL_GTGREFCLK_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_GTGREFCLK_VAL                  (1'b0),
  .GTHE4_CHANNEL_GTHRXN_TIE_EN                  (1'b0),
  .GTHE4_CHANNEL_GTHRXN_VAL                     (1'b0),
  .GTHE4_CHANNEL_GTHRXP_TIE_EN                  (1'b0),
  .GTHE4_CHANNEL_GTHRXP_VAL                     (1'b0),
  .GTHE4_CHANNEL_GTNORTHREFCLK0_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_GTNORTHREFCLK0_VAL             (1'b0),
  .GTHE4_CHANNEL_GTNORTHREFCLK1_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_GTNORTHREFCLK1_VAL             (1'b0),
  .GTHE4_CHANNEL_GTREFCLK0_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_GTREFCLK0_VAL                  (1'b0),
  .GTHE4_CHANNEL_GTREFCLK1_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_GTREFCLK1_VAL                  (1'b0),
  .GTHE4_CHANNEL_GTRSVD_TIE_EN                  (1'b0),
  .GTHE4_CHANNEL_GTRSVD_VAL                     (16'b0000000000000000),
  .GTHE4_CHANNEL_GTRXRESETSEL_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_GTRXRESETSEL_VAL               (1'b0),
  .GTHE4_CHANNEL_GTRXRESET_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_GTRXRESET_VAL                  (1'b0),
  .GTHE4_CHANNEL_GTSOUTHREFCLK0_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_GTSOUTHREFCLK0_VAL             (1'b0),
  .GTHE4_CHANNEL_GTSOUTHREFCLK1_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_GTSOUTHREFCLK1_VAL             (1'b0),
  .GTHE4_CHANNEL_GTTXRESETSEL_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_GTTXRESETSEL_VAL               (1'b0),
  .GTHE4_CHANNEL_GTTXRESET_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_GTTXRESET_VAL                  (1'b0),
  .GTHE4_CHANNEL_INCPCTRL_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_INCPCTRL_VAL                   (1'b0),
  .GTHE4_CHANNEL_ISCAN_CK_PH_SEL2               (1'b0),
  .GTHE4_CHANNEL_LOCAL_MASTER                   (1'b1),
  .GTHE4_CHANNEL_LOOPBACK_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_LOOPBACK_VAL                   (3'b000),
  .GTHE4_CHANNEL_LPBK_BIAS_CTRL                 (3'b100),
  .GTHE4_CHANNEL_LPBK_EN_RCAL_B                 (1'b0),
  .GTHE4_CHANNEL_LPBK_EXT_RCAL                  (4'b1000),
  .GTHE4_CHANNEL_LPBK_IND_CTRL0                 (3'b000),
  .GTHE4_CHANNEL_LPBK_IND_CTRL1                 (3'b000),
  .GTHE4_CHANNEL_LPBK_IND_CTRL2                 (3'b000),
  .GTHE4_CHANNEL_LPBK_RG_CTRL                   (4'b1110),
  .GTHE4_CHANNEL_OOBDIVCTL                      (2'b00),
  .GTHE4_CHANNEL_OOB_PWRUP                      (1'b0),
  .GTHE4_CHANNEL_PCI3_AUTO_REALIGN              ("OVR_1K_BLK"),
  .GTHE4_CHANNEL_PCI3_PIPE_RX_ELECIDLE          (1'b0),
  .GTHE4_CHANNEL_PCI3_RX_ASYNC_EBUF_BYPASS      (2'b00),
  .GTHE4_CHANNEL_PCI3_RX_ELECIDLE_EI2_ENABLE    (1'b0),
  .GTHE4_CHANNEL_PCI3_RX_ELECIDLE_H2L_COUNT     (6'b000000),
  .GTHE4_CHANNEL_PCI3_RX_ELECIDLE_H2L_DISABLE   (3'b000),
  .GTHE4_CHANNEL_PCI3_RX_ELECIDLE_HI_COUNT      (6'b000000),
  .GTHE4_CHANNEL_PCI3_RX_ELECIDLE_LP4_DISABLE   (1'b0),
  .GTHE4_CHANNEL_PCI3_RX_FIFO_DISABLE           (1'b0),
  .GTHE4_CHANNEL_PCIE3_CLK_COR_EMPTY_THRSH      (5'b00000),
  .GTHE4_CHANNEL_PCIE3_CLK_COR_FULL_THRSH       (6'b010000),
  .GTHE4_CHANNEL_PCIE3_CLK_COR_MAX_LAT          (5'b00100),
  .GTHE4_CHANNEL_PCIE3_CLK_COR_MIN_LAT          (5'b00000),
  .GTHE4_CHANNEL_PCIE3_CLK_COR_THRSH_TIMER      (6'b001000),
  .GTHE4_CHANNEL_PCIEEQRXEQADAPTDONE_TIE_EN     (1'b0),
  .GTHE4_CHANNEL_PCIEEQRXEQADAPTDONE_VAL        (1'b0),
  .GTHE4_CHANNEL_PCIERSTIDLE_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_PCIERSTIDLE_VAL                (1'b0),
  .GTHE4_CHANNEL_PCIERSTTXSYNCSTART_TIE_EN      (1'b0),
  .GTHE4_CHANNEL_PCIERSTTXSYNCSTART_VAL         (1'b0),
  .GTHE4_CHANNEL_PCIEUSERRATEDONE_TIE_EN        (1'b0),
  .GTHE4_CHANNEL_PCIEUSERRATEDONE_VAL           (1'b0),
  .GTHE4_CHANNEL_PCIE_BUFG_DIV_CTRL             (16'b0001000000000000),
  .GTHE4_CHANNEL_PCIE_PLL_SEL_MODE_GEN12        (2'b00),
  .GTHE4_CHANNEL_PCIE_PLL_SEL_MODE_GEN3         (2'b11),
  .GTHE4_CHANNEL_PCIE_PLL_SEL_MODE_GEN4         (2'b10),
  .GTHE4_CHANNEL_PCIE_RXPCS_CFG_GEN3            (16'b0000101010100101),
  .GTHE4_CHANNEL_PCIE_RXPMA_CFG                 (16'b0010100000001010),
  .GTHE4_CHANNEL_PCIE_TXPCS_CFG_GEN3            (16'b0010110010100100),
  .GTHE4_CHANNEL_PCIE_TXPMA_CFG                 (16'b0010100000001010),
  .GTHE4_CHANNEL_PCSRSVDIN_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_PCSRSVDIN_VAL                  (16'b0000000000000000),
  .GTHE4_CHANNEL_PCS_PCIE_EN                    ("FALSE"),
  .GTHE4_CHANNEL_PCS_RSVD0                      (16'b0000000000000000),
  .GTHE4_CHANNEL_PD_TRANS_TIME_FROM_P2          (12'b000000111100),
  .GTHE4_CHANNEL_PD_TRANS_TIME_NONE_P2          (8'b00011001),
  .GTHE4_CHANNEL_PD_TRANS_TIME_TO_P2            (8'b01100100),
  .GTHE4_CHANNEL_PREIQ_FREQ_BST                 (0),
  .GTHE4_CHANNEL_PROCESS_PAR                    (3'b010),
  .GTHE4_CHANNEL_QPLL0CLK_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_QPLL0CLK_VAL                   (1'b0),
  .GTHE4_CHANNEL_QPLL0FREQLOCK_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_QPLL0FREQLOCK_VAL              (1'b0),
  .GTHE4_CHANNEL_QPLL0REFCLK_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_QPLL0REFCLK_VAL                (1'b0),
  .GTHE4_CHANNEL_QPLL1CLK_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_QPLL1CLK_VAL                   (1'b0),
  .GTHE4_CHANNEL_QPLL1FREQLOCK_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_QPLL1FREQLOCK_VAL              (1'b0),
  .GTHE4_CHANNEL_QPLL1REFCLK_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_QPLL1REFCLK_VAL                (1'b0),
  .GTHE4_CHANNEL_RATE_SW_USE_DRP                (1'b1),
  .GTHE4_CHANNEL_RCLK_SIPO_DLY_ENB              (1'b0),
  .GTHE4_CHANNEL_RCLK_SIPO_INV_EN               (1'b0),
  .GTHE4_CHANNEL_RESETOVRD_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_RESETOVRD_VAL                  (1'b0),
  .GTHE4_CHANNEL_RESET_POWERSAVE_DISABLE        (1'b0),
  .GTHE4_CHANNEL_RTX_BUF_CML_CTRL               (3'b010),
  .GTHE4_CHANNEL_RTX_BUF_TERM_CTRL              (2'b00),
  .GTHE4_CHANNEL_RX8B10BEN_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_RX8B10BEN_VAL                  (1'b1),
  .GTHE4_CHANNEL_RXAFECFOKEN_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXAFECFOKEN_VAL                (1'b1),
  .GTHE4_CHANNEL_RXBUFRESET_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_RXBUFRESET_TIME                (5'b00011),
  .GTHE4_CHANNEL_RXBUFRESET_VAL                 (1'b0),
  .GTHE4_CHANNEL_RXBUF_ADDR_MODE                ("FAST"),
  .GTHE4_CHANNEL_RXBUF_EIDLE_HI_CNT             (4'b1000),
  .GTHE4_CHANNEL_RXBUF_EIDLE_LO_CNT             (4'b0000),
  .GTHE4_CHANNEL_RXBUF_EN                       ("FALSE"),
  .GTHE4_CHANNEL_RXBUF_RESET_ON_CB_CHANGE       ("TRUE"),
  .GTHE4_CHANNEL_RXBUF_RESET_ON_COMMAALIGN      ("FALSE"),
  .GTHE4_CHANNEL_RXBUF_RESET_ON_EIDLE           ("FALSE"),
  .GTHE4_CHANNEL_RXBUF_RESET_ON_RATE_CHANGE     ("TRUE"),
  .GTHE4_CHANNEL_RXBUF_THRESH_OVFLW             (0),
  .GTHE4_CHANNEL_RXBUF_THRESH_OVRD              ("FALSE"),
  .GTHE4_CHANNEL_RXBUF_THRESH_UNDFLW            (4),
  .GTHE4_CHANNEL_RXCDRFREQRESET_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXCDRFREQRESET_TIME            (5'b00001),
  .GTHE4_CHANNEL_RXCDRFREQRESET_VAL             (1'b0),
  .GTHE4_CHANNEL_RXCDRHOLD_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_RXCDRHOLD_VAL                  (1'b0),
  .GTHE4_CHANNEL_RXCDROVRDEN_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXCDROVRDEN_VAL                (1'b0),
  .GTHE4_CHANNEL_RXCDRPHRESET_TIME              (5'b00001),
  .GTHE4_CHANNEL_RXCDRRESET_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_RXCDRRESET_VAL                 (1'b0),
  .GTHE4_CHANNEL_RXCDR_CFG0                     (16'b0000000000000011),
  .GTHE4_CHANNEL_RXCDR_CFG0_GEN3                (16'b0000000000000011),
  .GTHE4_CHANNEL_RXCDR_CFG1                     (16'b0000000000000000),
  .GTHE4_CHANNEL_RXCDR_CFG1_GEN3                (16'b0000000000000000),
  .GTHE4_CHANNEL_RXCDR_CFG2                     (16'b0000001001001001),
  .GTHE4_CHANNEL_RXCDR_CFG2_GEN2                (10'b1001001001),
  .GTHE4_CHANNEL_RXCDR_CFG2_GEN3                (16'b0000001001001001),
  .GTHE4_CHANNEL_RXCDR_CFG2_GEN4                (16'b0000000101100100),
  .GTHE4_CHANNEL_RXCDR_CFG3                     (16'b0000000000010010),
  .GTHE4_CHANNEL_RXCDR_CFG3_GEN2                (6'b010010),
  .GTHE4_CHANNEL_RXCDR_CFG3_GEN3                (16'b0000000000010010),
  .GTHE4_CHANNEL_RXCDR_CFG3_GEN4                (16'b0000000000010010),
  .GTHE4_CHANNEL_RXCDR_CFG4                     (16'b0101110011110110),
  .GTHE4_CHANNEL_RXCDR_CFG4_GEN3                (16'b0101110011110110),
  .GTHE4_CHANNEL_RXCDR_CFG5                     (16'b1011010001101011),
  .GTHE4_CHANNEL_RXCDR_CFG5_GEN3                (16'b0001010001101011),
  .GTHE4_CHANNEL_RXCDR_FR_RESET_ON_EIDLE        (1'b0),
  .GTHE4_CHANNEL_RXCDR_HOLD_DURING_EIDLE        (1'b0),
  .GTHE4_CHANNEL_RXCDR_LOCK_CFG0                (16'b0010001000000001),
  .GTHE4_CHANNEL_RXCDR_LOCK_CFG1                (16'b1001111111111111),
  .GTHE4_CHANNEL_RXCDR_LOCK_CFG2                (16'b0111011111000011),
  .GTHE4_CHANNEL_RXCDR_LOCK_CFG3                (16'b0000000000000001),
  .GTHE4_CHANNEL_RXCDR_LOCK_CFG4                (16'b0000000000000000),
  .GTHE4_CHANNEL_RXCDR_PH_RESET_ON_EIDLE        (1'b0),
  .GTHE4_CHANNEL_RXCFOK_CFG0                    (16'b0000000000000000),
  .GTHE4_CHANNEL_RXCFOK_CFG1                    (16'b1000000000010101),
  .GTHE4_CHANNEL_RXCFOK_CFG2                    (16'b0000001010101110),
  .GTHE4_CHANNEL_RXCHBONDEN_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_RXCHBONDEN_VAL                 (1'b0),
  .GTHE4_CHANNEL_RXCHBONDI_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_RXCHBONDI_VAL                  (5'b00000),
  .GTHE4_CHANNEL_RXCHBONDLEVEL_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXCHBONDLEVEL_VAL              (3'b000),
  .GTHE4_CHANNEL_RXCHBONDMASTER_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXCHBONDMASTER_VAL             (1'b0),
  .GTHE4_CHANNEL_RXCHBONDSLAVE_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXCHBONDSLAVE_VAL              (1'b0),
  .GTHE4_CHANNEL_RXCKCAL1_IQ_LOOP_RST_CFG       (16'b0000000000000100),
  .GTHE4_CHANNEL_RXCKCAL1_I_LOOP_RST_CFG        (16'b0000000000000100),
  .GTHE4_CHANNEL_RXCKCAL1_Q_LOOP_RST_CFG        (16'b0000000000000100),
  .GTHE4_CHANNEL_RXCKCAL2_DX_LOOP_RST_CFG       (16'b0000000000000100),
  .GTHE4_CHANNEL_RXCKCAL2_D_LOOP_RST_CFG        (16'b0000000000000100),
  .GTHE4_CHANNEL_RXCKCAL2_S_LOOP_RST_CFG        (16'b0000000000000100),
  .GTHE4_CHANNEL_RXCKCAL2_X_LOOP_RST_CFG        (16'b0000000000000100),
  .GTHE4_CHANNEL_RXCKCALRESET_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_RXCKCALRESET_VAL               (1'b0),
  .GTHE4_CHANNEL_RXCKCALSTART_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_RXCKCALSTART_VAL               (7'b0000000),
  .GTHE4_CHANNEL_RXCOMMADETEN_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_RXCOMMADETEN_VAL               (1'b1),
  .GTHE4_CHANNEL_RXDFEAGCCTRL_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_RXDFEAGCCTRL_VAL               (2'b01),
  .GTHE4_CHANNEL_RXDFEAGCHOLD_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_RXDFEAGCHOLD_VAL               (1'b0),
  .GTHE4_CHANNEL_RXDFEAGCOVRDEN_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXDFEAGCOVRDEN_VAL             (1'b0),
  .GTHE4_CHANNEL_RXDFECFOKFCNUM_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXDFECFOKFCNUM_VAL             (4'b1101),
  .GTHE4_CHANNEL_RXDFECFOKFEN_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_RXDFECFOKFEN_VAL               (1'b0),
  .GTHE4_CHANNEL_RXDFECFOKFPULSE_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_RXDFECFOKFPULSE_VAL            (1'b0),
  .GTHE4_CHANNEL_RXDFECFOKHOLD_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFECFOKHOLD_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFECFOKOVREN_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXDFECFOKOVREN_VAL             (1'b0),
  .GTHE4_CHANNEL_RXDFEKHHOLD_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXDFEKHHOLD_VAL                (1'b0),
  .GTHE4_CHANNEL_RXDFEKHOVRDEN_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFEKHOVRDEN_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFELFHOLD_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXDFELFHOLD_VAL                (1'b0),
  .GTHE4_CHANNEL_RXDFELFOVRDEN_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFELFOVRDEN_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFELPMRESET_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFELPMRESET_TIME             (7'b0001111),
  .GTHE4_CHANNEL_RXDFELPMRESET_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFELPM_KL_CFG0               (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFELPM_KL_CFG1               (16'b1010000011100010),
  .GTHE4_CHANNEL_RXDFELPM_KL_CFG2               (16'b0000000100000000),
  .GTHE4_CHANNEL_RXDFETAP10HOLD_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXDFETAP10HOLD_VAL             (1'b0),
  .GTHE4_CHANNEL_RXDFETAP10OVRDEN_TIE_EN        (1'b0),
  .GTHE4_CHANNEL_RXDFETAP10OVRDEN_VAL           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP11HOLD_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXDFETAP11HOLD_VAL             (1'b0),
  .GTHE4_CHANNEL_RXDFETAP11OVRDEN_TIE_EN        (1'b0),
  .GTHE4_CHANNEL_RXDFETAP11OVRDEN_VAL           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP12HOLD_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXDFETAP12HOLD_VAL             (1'b0),
  .GTHE4_CHANNEL_RXDFETAP12OVRDEN_TIE_EN        (1'b0),
  .GTHE4_CHANNEL_RXDFETAP12OVRDEN_VAL           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP13HOLD_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXDFETAP13HOLD_VAL             (1'b0),
  .GTHE4_CHANNEL_RXDFETAP13OVRDEN_TIE_EN        (1'b0),
  .GTHE4_CHANNEL_RXDFETAP13OVRDEN_VAL           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP14HOLD_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXDFETAP14HOLD_VAL             (1'b0),
  .GTHE4_CHANNEL_RXDFETAP14OVRDEN_TIE_EN        (1'b0),
  .GTHE4_CHANNEL_RXDFETAP14OVRDEN_VAL           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP15HOLD_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXDFETAP15HOLD_VAL             (1'b0),
  .GTHE4_CHANNEL_RXDFETAP15OVRDEN_TIE_EN        (1'b0),
  .GTHE4_CHANNEL_RXDFETAP15OVRDEN_VAL           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP2HOLD_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP2HOLD_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFETAP2OVRDEN_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_RXDFETAP2OVRDEN_VAL            (1'b0),
  .GTHE4_CHANNEL_RXDFETAP3HOLD_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP3HOLD_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFETAP3OVRDEN_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_RXDFETAP3OVRDEN_VAL            (1'b0),
  .GTHE4_CHANNEL_RXDFETAP4HOLD_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP4HOLD_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFETAP4OVRDEN_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_RXDFETAP4OVRDEN_VAL            (1'b0),
  .GTHE4_CHANNEL_RXDFETAP5HOLD_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP5HOLD_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFETAP5OVRDEN_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_RXDFETAP5OVRDEN_VAL            (1'b0),
  .GTHE4_CHANNEL_RXDFETAP6HOLD_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP6HOLD_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFETAP6OVRDEN_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_RXDFETAP6OVRDEN_VAL            (1'b0),
  .GTHE4_CHANNEL_RXDFETAP7HOLD_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP7HOLD_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFETAP7OVRDEN_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_RXDFETAP7OVRDEN_VAL            (1'b0),
  .GTHE4_CHANNEL_RXDFETAP8HOLD_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP8HOLD_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFETAP8OVRDEN_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_RXDFETAP8OVRDEN_VAL            (1'b0),
  .GTHE4_CHANNEL_RXDFETAP9HOLD_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFETAP9HOLD_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFETAP9OVRDEN_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_RXDFETAP9OVRDEN_VAL            (1'b0),
  .GTHE4_CHANNEL_RXDFEUTHOLD_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXDFEUTHOLD_VAL                (1'b0),
  .GTHE4_CHANNEL_RXDFEUTOVRDEN_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFEUTOVRDEN_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFEVPHOLD_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXDFEVPHOLD_VAL                (1'b0),
  .GTHE4_CHANNEL_RXDFEVPOVRDEN_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXDFEVPOVRDEN_VAL              (1'b0),
  .GTHE4_CHANNEL_RXDFEXYDEN_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_RXDFEXYDEN_VAL                 (1'b1),
  .GTHE4_CHANNEL_RXDFE_CFG0                     (16'b0000101000000000),
  .GTHE4_CHANNEL_RXDFE_CFG1                     (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_GC_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_GC_CFG1                  (16'b1000000000000000),
  .GTHE4_CHANNEL_RXDFE_GC_CFG2                  (16'b1111111111100000),
  .GTHE4_CHANNEL_RXDFE_H2_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_H2_CFG1                  (16'b0000000000000010),
  .GTHE4_CHANNEL_RXDFE_H3_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_H3_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_H4_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_H4_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_H5_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_H5_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_H6_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_H6_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_H7_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_H7_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_H8_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_H8_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_H9_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_H9_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_HA_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_HA_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_HB_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_HB_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_HC_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_HC_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_HD_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_HD_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_HE_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_HE_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_HF_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_HF_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_KH_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_KH_CFG1                  (16'b1000000000000000),
  .GTHE4_CHANNEL_RXDFE_KH_CFG2                  (16'b0010011000010011),
  .GTHE4_CHANNEL_RXDFE_KH_CFG3                  (16'b0100000100011100),
  .GTHE4_CHANNEL_RXDFE_OS_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_OS_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXDFE_PWR_SAVING               (1'b1),
  .GTHE4_CHANNEL_RXDFE_UT_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_UT_CFG1                  (16'b0000000000000011),
  .GTHE4_CHANNEL_RXDFE_UT_CFG2                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_VP_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXDFE_VP_CFG1                  (16'b1000000000110011),
  .GTHE4_CHANNEL_RXDLYBYPASS_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXDLYBYPASS_VAL                (1'b0),
  .GTHE4_CHANNEL_RXDLYEN_TIE_EN                 (1'b0),
  .GTHE4_CHANNEL_RXDLYEN_VAL                    (1'b0),
  .GTHE4_CHANNEL_RXDLYOVRDEN_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXDLYOVRDEN_VAL                (1'b0),
  .GTHE4_CHANNEL_RXDLYSRESET_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXDLYSRESET_VAL                (1'b0),
  .GTHE4_CHANNEL_RXDLY_CFG                      (16'b0000000000010000),
  .GTHE4_CHANNEL_RXDLY_LCFG                     (16'b0000000000110000),
  .GTHE4_CHANNEL_RXELECIDLEMODE_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXELECIDLEMODE_VAL             (2'b11),
  .GTHE4_CHANNEL_RXELECIDLE_CFG                 ("SIGCFG_4"),
  .GTHE4_CHANNEL_RXEQTRAINING_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_RXEQTRAINING_VAL               (1'b0),
  .GTHE4_CHANNEL_RXGBOX_FIFO_INIT_RD_ADDR       (4),
  .GTHE4_CHANNEL_RXGEARBOXSLIP_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXGEARBOXSLIP_VAL              (1'b0),
  .GTHE4_CHANNEL_RXGEARBOX_EN                   ("FALSE"),
  .GTHE4_CHANNEL_RXISCANRESET_TIME              (5'b00001),
  .GTHE4_CHANNEL_RXLATCLK_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_RXLATCLK_VAL                   (1'b0),
  .GTHE4_CHANNEL_RXLPMEN_TIE_EN                 (1'b0),
  .GTHE4_CHANNEL_RXLPMEN_VAL                    (1'b1),
  .GTHE4_CHANNEL_RXLPMGCHOLD_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXLPMGCHOLD_VAL                (1'b0),
  .GTHE4_CHANNEL_RXLPMGCOVRDEN_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXLPMGCOVRDEN_VAL              (1'b0),
  .GTHE4_CHANNEL_RXLPMHFHOLD_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXLPMHFHOLD_VAL                (1'b0),
  .GTHE4_CHANNEL_RXLPMHFOVRDEN_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXLPMHFOVRDEN_VAL              (1'b0),
  .GTHE4_CHANNEL_RXLPMLFHOLD_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXLPMLFHOLD_VAL                (1'b0),
  .GTHE4_CHANNEL_RXLPMLFKLOVRDEN_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_RXLPMLFKLOVRDEN_VAL            (1'b0),
  .GTHE4_CHANNEL_RXLPMOSHOLD_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXLPMOSHOLD_VAL                (1'b0),
  .GTHE4_CHANNEL_RXLPMOSOVRDEN_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXLPMOSOVRDEN_VAL              (1'b0),
  .GTHE4_CHANNEL_RXLPM_CFG                      (16'b0000000000000000),
  .GTHE4_CHANNEL_RXLPM_GC_CFG                   (16'b1000000000000000),
  .GTHE4_CHANNEL_RXLPM_KH_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXLPM_KH_CFG1                  (16'b0000000000000010),
  .GTHE4_CHANNEL_RXLPM_OS_CFG0                  (16'b0000000000000000),
  .GTHE4_CHANNEL_RXLPM_OS_CFG1                  (16'b1000000000000010),
  .GTHE4_CHANNEL_RXMCOMMAALIGNEN_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_RXMCOMMAALIGNEN_VAL            (1'b1),
  .GTHE4_CHANNEL_RXMONITORSEL_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_RXMONITORSEL_VAL               (2'b00),
  .GTHE4_CHANNEL_RXOOBRESET_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_RXOOBRESET_VAL                 (1'b0),
  .GTHE4_CHANNEL_RXOOB_CFG                      (9'b000000110),
  .GTHE4_CHANNEL_RXOOB_CLK_CFG                  ("PMA"),
  .GTHE4_CHANNEL_RXOSCALRESET_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_RXOSCALRESET_TIME              (5'b00011),
  .GTHE4_CHANNEL_RXOSCALRESET_VAL               (1'b0),
  .GTHE4_CHANNEL_RXOSHOLD_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_RXOSHOLD_VAL                   (1'b0),
  .GTHE4_CHANNEL_RXOSOVRDEN_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_RXOSOVRDEN_VAL                 (1'b0),
  .GTHE4_CHANNEL_RXOUTCLKSEL_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXOUTCLKSEL_VAL                (3'b010),
  .GTHE4_CHANNEL_RXOUT_DIV                      (4),
  .GTHE4_CHANNEL_RXPCOMMAALIGNEN_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_RXPCOMMAALIGNEN_VAL            (1'b1),
  .GTHE4_CHANNEL_RXPCSRESET_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_RXPCSRESET_TIME                (5'b00011),
  .GTHE4_CHANNEL_RXPCSRESET_VAL                 (1'b0),
  .GTHE4_CHANNEL_RXPD_TIE_EN                    (1'b0),
  .GTHE4_CHANNEL_RXPD_VAL                       (2'b00),
  .GTHE4_CHANNEL_RXPHALIGNEN_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXPHALIGNEN_VAL                (1'b0),
  .GTHE4_CHANNEL_RXPHALIGN_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_RXPHALIGN_VAL                  (1'b0),
  .GTHE4_CHANNEL_RXPHBEACON_CFG                 (16'b0000000000000000),
  .GTHE4_CHANNEL_RXPHDLYPD_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_RXPHDLYPD_VAL                  (1'b0),
  .GTHE4_CHANNEL_RXPHDLYRESET_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_RXPHDLYRESET_VAL               (1'b0),
  .GTHE4_CHANNEL_RXPHDLY_CFG                    (16'b0010000001110000),
  .GTHE4_CHANNEL_RXPHOVRDEN_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_RXPHOVRDEN_VAL                 (1'b0),
  .GTHE4_CHANNEL_RXPHSAMP_CFG                   (16'b0010000100000000),
  .GTHE4_CHANNEL_RXPHSLIP_CFG                   (16'b1001100100110011),
  .GTHE4_CHANNEL_RXPH_MONITOR_SEL               (5'b00000),
  .GTHE4_CHANNEL_RXPI_AUTO_BW_SEL_BYPASS        (1'b0),
  .GTHE4_CHANNEL_RXPI_CFG0                      (16'b0001001100000000),
  .GTHE4_CHANNEL_RXPI_CFG1                      (16'b0000000011111101),
  .GTHE4_CHANNEL_RXPI_LPM                       (1'b0),
  .GTHE4_CHANNEL_RXPI_SEL_LC                    (2'b00),
  .GTHE4_CHANNEL_RXPI_STARTCODE                 (2'b00),
  .GTHE4_CHANNEL_RXPI_VREFSEL                   (1'b0),
  .GTHE4_CHANNEL_RXPLLCLKSEL_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXPLLCLKSEL_VAL                (2'b00),
  .GTHE4_CHANNEL_RXPMACLK_SEL                   ("DATA"),
  .GTHE4_CHANNEL_RXPMARESET_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_RXPMARESET_TIME                (5'b00011),
  .GTHE4_CHANNEL_RXPMARESET_VAL                 (1'b0),
  .GTHE4_CHANNEL_RXPOLARITY_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_RXPOLARITY_VAL                 (1'b0),
  .GTHE4_CHANNEL_RXPRBSCNTRESET_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXPRBSCNTRESET_VAL             (1'b0),
  .GTHE4_CHANNEL_RXPRBSSEL_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_RXPRBSSEL_VAL                  (4'b0000),
  .GTHE4_CHANNEL_RXPRBS_ERR_LOOPBACK            (1'b0),
  .GTHE4_CHANNEL_RXPRBS_LINKACQ_CNT             (15),
  .GTHE4_CHANNEL_RXPROGDIVRESET_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_RXPROGDIVRESET_VAL             (1'b0),
  .GTHE4_CHANNEL_RXQPIEN_TIE_EN                 (1'b0),
  .GTHE4_CHANNEL_RXQPIEN_VAL                    (1'b0),
  .GTHE4_CHANNEL_RXRATEMODE_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_RXRATEMODE_VAL                 (1'b0),
  .GTHE4_CHANNEL_RXRATE_TIE_EN                  (1'b0),
  .GTHE4_CHANNEL_RXRATE_VAL                     (3'b000),
  .GTHE4_CHANNEL_RXREFCLKDIV2_SEL               (1'b0),
  .GTHE4_CHANNEL_RXSLIDE_AUTO_WAIT              (7),
  .GTHE4_CHANNEL_RXSLIDE_MODE                   ("PCS"),
  .GTHE4_CHANNEL_RXSLIDE_TIE_EN                 (1'b0),
  .GTHE4_CHANNEL_RXSLIDE_VAL                    (1'b0),
  .GTHE4_CHANNEL_RXSLIPOUTCLK_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_RXSLIPOUTCLK_VAL               (1'b0),
  .GTHE4_CHANNEL_RXSLIPPMA_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_RXSLIPPMA_VAL                  (1'b0),
  .GTHE4_CHANNEL_RXSYNCALLIN_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXSYNCALLIN_VAL                (1'b0),
  .GTHE4_CHANNEL_RXSYNCIN_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_RXSYNCIN_VAL                   (1'b0),
  .GTHE4_CHANNEL_RXSYNCMODE_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_RXSYNCMODE_VAL                 (1'b0),
  .GTHE4_CHANNEL_RXSYNC_MULTILANE               (1'b0),
  .GTHE4_CHANNEL_RXSYNC_OVRD                    (1'b0),
  .GTHE4_CHANNEL_RXSYNC_SKIP_DA                 (1'b1),
  .GTHE4_CHANNEL_RXSYSCLKSEL_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_RXSYSCLKSEL_VAL                (2'b00),
  .GTHE4_CHANNEL_RXTERMINATION_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_RXTERMINATION_VAL              (1'b0),
  .GTHE4_CHANNEL_RXUSERRDY_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_RXUSERRDY_VAL                  (1'b1),
  .GTHE4_CHANNEL_RXUSRCLK2_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_RXUSRCLK2_VAL                  (1'b0),
  .GTHE4_CHANNEL_RXUSRCLK_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_RXUSRCLK_VAL                   (1'b0),
  .GTHE4_CHANNEL_RX_AFE_CM_EN                   (1'b0),
  .GTHE4_CHANNEL_RX_BIAS_CFG0                   (16'b0001010101010100),
  .GTHE4_CHANNEL_RX_BUFFER_CFG                  (6'b000000),
  .GTHE4_CHANNEL_RX_CAPFF_SARC_ENB              (1'b0),
  .GTHE4_CHANNEL_RX_CLK25_DIV                   (5),
  .GTHE4_CHANNEL_RX_CLKMUX_EN                   (1'b1),
  .GTHE4_CHANNEL_RX_CLK_SLIP_OVRD               (5'b00000),
  .GTHE4_CHANNEL_RX_CM_BUF_CFG                  (4'b1010),
  .GTHE4_CHANNEL_RX_CM_BUF_PD                   (1'b0),
  .GTHE4_CHANNEL_RX_CM_SEL                      (3),
  .GTHE4_CHANNEL_RX_CM_TRIM                     (10),
  .GTHE4_CHANNEL_RX_CTLE3_LPF                   (8'b11111111),
  .GTHE4_CHANNEL_RX_DATA_WIDTH                  (20),
  .GTHE4_CHANNEL_RX_DDI_SEL                     (6'b000000),
  .GTHE4_CHANNEL_RX_DEFER_RESET_BUF_EN          ("TRUE"),
  .GTHE4_CHANNEL_RX_DEGEN_CTRL                  (3'b011),
  .GTHE4_CHANNEL_RX_DFELPM_CFG0                 (6),
  .GTHE4_CHANNEL_RX_DFELPM_CFG1                 (1'b1),
  .GTHE4_CHANNEL_RX_DFELPM_KLKH_AGC_STUP_EN     (1'b1),
  .GTHE4_CHANNEL_RX_DFE_AGC_CFG0                (2'b10),
  .GTHE4_CHANNEL_RX_DFE_AGC_CFG1                (4),
  .GTHE4_CHANNEL_RX_DFE_KL_LPM_KH_CFG0          (1),
  .GTHE4_CHANNEL_RX_DFE_KL_LPM_KH_CFG1          (4),
  .GTHE4_CHANNEL_RX_DFE_KL_LPM_KL_CFG0          (2'b01),
  .GTHE4_CHANNEL_RX_DFE_KL_LPM_KL_CFG1          (4),
  .GTHE4_CHANNEL_RX_DFE_LPM_HOLD_DURING_EIDLE   (1'b0),
  .GTHE4_CHANNEL_RX_DISPERR_SEQ_MATCH           ("TRUE"),
  .GTHE4_CHANNEL_RX_DIV2_MODE_B                 (1'b0),
  .GTHE4_CHANNEL_RX_DIVRESET_TIME               (5'b00001),
  .GTHE4_CHANNEL_RX_EN_CTLE_RCAL_B              (1'b0),
  .GTHE4_CHANNEL_RX_EN_HI_LR                    (1'b1),
  .GTHE4_CHANNEL_RX_EXT_RL_CTRL                 (9'b000000000),
  .GTHE4_CHANNEL_RX_EYESCAN_VS_CODE             (7'b0000000),
  .GTHE4_CHANNEL_RX_EYESCAN_VS_NEG_DIR          (1'b0),
  .GTHE4_CHANNEL_RX_EYESCAN_VS_RANGE            (2'b00),
  .GTHE4_CHANNEL_RX_EYESCAN_VS_UT_SIGN          (1'b0),
  .GTHE4_CHANNEL_RX_FABINT_USRCLK_FLOP          (1'b0),
  .GTHE4_CHANNEL_RX_INT_DATAWIDTH               (0),
  .GTHE4_CHANNEL_RX_PMA_POWER_SAVE              (1'b0),
  .GTHE4_CHANNEL_RX_PMA_RSV0                    (16'b0000000000000000),
  .GTHE4_CHANNEL_RX_PROGDIV_CFG                 (0.0),
  .GTHE4_CHANNEL_RX_PROGDIV_RATE                (16'b0000000000000001),
  .GTHE4_CHANNEL_RX_RESLOAD_CTRL                (4'b0000),
  .GTHE4_CHANNEL_RX_RESLOAD_OVRD                (1'b0),
  .GTHE4_CHANNEL_RX_SAMPLE_PERIOD               (3'b111),
  .GTHE4_CHANNEL_RX_SIG_VALID_DLY               (11),
  .GTHE4_CHANNEL_RX_SUM_DFETAPREP_EN            (1'b0),
  .GTHE4_CHANNEL_RX_SUM_IREF_TUNE               (4'b0100),
  .GTHE4_CHANNEL_RX_SUM_RESLOAD_CTRL            (4'b0011),
  .GTHE4_CHANNEL_RX_SUM_VCMTUNE                 (4'b0110),
  .GTHE4_CHANNEL_RX_SUM_VCM_OVWR                (1'b0),
  .GTHE4_CHANNEL_RX_SUM_VREF_TUNE               (3'b100),
  .GTHE4_CHANNEL_RX_TUNE_AFE_OS                 (2'b00),
  .GTHE4_CHANNEL_RX_VREG_CTRL                   (3'b101),
  .GTHE4_CHANNEL_RX_VREG_PDB                    (1'b1),
  .GTHE4_CHANNEL_RX_WIDEMODE_CDR                (2'b00),
  .GTHE4_CHANNEL_RX_WIDEMODE_CDR_GEN3           (2'b00),
  .GTHE4_CHANNEL_RX_WIDEMODE_CDR_GEN4           (2'b01),
  .GTHE4_CHANNEL_RX_XCLK_SEL                    ("RXUSR"),
  .GTHE4_CHANNEL_RX_XMODE_SEL                   (1'b0),
  .GTHE4_CHANNEL_SAMPLE_CLK_PHASE               (1'b0),
  .GTHE4_CHANNEL_SAS_12G_MODE                   (1'b0),
  .GTHE4_CHANNEL_SATA_BURST_SEQ_LEN             (4'b1111),
  .GTHE4_CHANNEL_SATA_BURST_VAL                 (3'b100),
  .GTHE4_CHANNEL_SATA_CPLL_CFG                  ("VCO_3000MHZ"),
  .GTHE4_CHANNEL_SATA_EIDLE_VAL                 (3'b100),
  .GTHE4_CHANNEL_SHOW_REALIGN_COMMA             ("FALSE"),
  .GTHE4_CHANNEL_SIGVALIDCLK_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_SIGVALIDCLK_VAL                (1'b0),
  .GTHE4_CHANNEL_SIM_DEVICE                     ("ULTRASCALE_PLUS"),
  .GTHE4_CHANNEL_SIM_MODE                       ("FAST"),
  .GTHE4_CHANNEL_SIM_RECEIVER_DETECT_PASS       ("TRUE"),
  .GTHE4_CHANNEL_SIM_RESET_SPEEDUP              ("TRUE"),
  .GTHE4_CHANNEL_SIM_TX_EIDLE_DRIVE_LEVEL       ("Z"),
  .GTHE4_CHANNEL_SRSTMODE                       (1'b0),
  .GTHE4_CHANNEL_TAPDLY_SET_TX                  (2'b00),
  .GTHE4_CHANNEL_TEMPERATURE_PAR                (4'b0010),
  .GTHE4_CHANNEL_TERM_RCAL_CFG                  (15'b100001000010001),
  .GTHE4_CHANNEL_TERM_RCAL_OVRD                 (3'b000),
  .GTHE4_CHANNEL_TRANS_TIME_RATE                (8'b00001110),
  .GTHE4_CHANNEL_TSTIN_TIE_EN                   (1'b0),
  .GTHE4_CHANNEL_TSTIN_VAL                      (20'b00000000000000000000),
  .GTHE4_CHANNEL_TST_RSV0                       (8'b00000000),
  .GTHE4_CHANNEL_TST_RSV1                       (8'b00000000),
  .GTHE4_CHANNEL_TX8B10BBYPASS_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_TX8B10BBYPASS_VAL              (8'b00000000),
  .GTHE4_CHANNEL_TX8B10BEN_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_TX8B10BEN_VAL                  (1'b1),
  .GTHE4_CHANNEL_TXBUF_EN                       ("FALSE"),
  .GTHE4_CHANNEL_TXBUF_RESET_ON_RATE_CHANGE     ("TRUE"),
  .GTHE4_CHANNEL_TXCOMINIT_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_TXCOMINIT_VAL                  (1'b0),
  .GTHE4_CHANNEL_TXCOMSAS_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_TXCOMSAS_VAL                   (1'b0),
  .GTHE4_CHANNEL_TXCOMWAKE_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_TXCOMWAKE_VAL                  (1'b0),
  .GTHE4_CHANNEL_TXCTRL0_TIE_EN                 (1'b0),
  .GTHE4_CHANNEL_TXCTRL0_VAL                    (16'b0000000000000000),
  .GTHE4_CHANNEL_TXCTRL1_TIE_EN                 (1'b0),
  .GTHE4_CHANNEL_TXCTRL1_VAL                    (16'b0000000000000000),
  .GTHE4_CHANNEL_TXCTRL2_TIE_EN                 (1'b0),
  .GTHE4_CHANNEL_TXCTRL2_VAL                    (8'b00000000),
  .GTHE4_CHANNEL_TXDATAEXTENDRSVD_TIE_EN        (1'b0),
  .GTHE4_CHANNEL_TXDATAEXTENDRSVD_VAL           (8'b00000000),
  .GTHE4_CHANNEL_TXDATA_TIE_EN                  (1'b0),
  .GTHE4_CHANNEL_TXDATA_VAL                     (128'b00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000),
  .GTHE4_CHANNEL_TXDCCFORCESTART_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_TXDCCFORCESTART_VAL            (1'b0),
  .GTHE4_CHANNEL_TXDCCRESET_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_TXDCCRESET_VAL                 (1'b0),
  .GTHE4_CHANNEL_TXDEEMPH_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_TXDEEMPH_VAL                   (1'b0),
  .GTHE4_CHANNEL_TXDETECTRX_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_TXDETECTRX_VAL                 (1'b0),
  .GTHE4_CHANNEL_TXDIFFCTRL_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_TXDIFFCTRL_VAL                 (5'b11000),
  .GTHE4_CHANNEL_TXDLYBYPASS_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_TXDLYBYPASS_VAL                (1'b0),
  .GTHE4_CHANNEL_TXDLYEN_TIE_EN                 (1'b0),
  .GTHE4_CHANNEL_TXDLYEN_VAL                    (1'b0),
  .GTHE4_CHANNEL_TXDLYHOLD_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_TXDLYHOLD_VAL                  (1'b0),
  .GTHE4_CHANNEL_TXDLYOVRDEN_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_TXDLYOVRDEN_VAL                (1'b0),
  .GTHE4_CHANNEL_TXDLYSRESET_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_TXDLYSRESET_VAL                (1'b0),
  .GTHE4_CHANNEL_TXDLYUPDOWN_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_TXDLYUPDOWN_VAL                (1'b0),
  .GTHE4_CHANNEL_TXDLY_CFG                      (16'b1000000000010000),
  .GTHE4_CHANNEL_TXDLY_LCFG                     (16'b0000000000110000),
  .GTHE4_CHANNEL_TXDRVBIAS_N                    (4'b1010),
  .GTHE4_CHANNEL_TXELECIDLE_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_TXELECIDLE_VAL                 (1'b0),
  .GTHE4_CHANNEL_TXFIFO_ADDR_CFG                ("LOW"),
  .GTHE4_CHANNEL_TXGBOX_FIFO_INIT_RD_ADDR       (4),
  .GTHE4_CHANNEL_TXGEARBOX_EN                   ("FALSE"),
  .GTHE4_CHANNEL_TXHEADER_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_TXHEADER_VAL                   (6'b000000),
  .GTHE4_CHANNEL_TXINHIBIT_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_TXINHIBIT_VAL                  (1'b0),
  .GTHE4_CHANNEL_TXLATCLK_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_TXLATCLK_VAL                   (1'b0),
  .GTHE4_CHANNEL_TXLFPSTRESET_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_TXLFPSTRESET_VAL               (1'b0),
  .GTHE4_CHANNEL_TXLFPSU2LPEXIT_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_TXLFPSU2LPEXIT_VAL             (1'b0),
  .GTHE4_CHANNEL_TXLFPSU3WAKE_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_TXLFPSU3WAKE_VAL               (1'b0),
  .GTHE4_CHANNEL_TXMAINCURSOR_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_TXMAINCURSOR_VAL               (7'b0000000),
  .GTHE4_CHANNEL_TXMARGIN_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_TXMARGIN_VAL                   (3'b000),
  .GTHE4_CHANNEL_TXMUXDCDEXHOLD_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_TXMUXDCDEXHOLD_VAL             (1'b0),
  .GTHE4_CHANNEL_TXMUXDCDORWREN_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_TXMUXDCDORWREN_VAL             (1'b0),
  .GTHE4_CHANNEL_TXONESZEROS_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_TXONESZEROS_VAL                (1'b0),
  .GTHE4_CHANNEL_TXOUTCLKSEL_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_TXOUTCLKSEL_VAL                (3'b011),
  .GTHE4_CHANNEL_TXOUT_DIV                      (4),
  .GTHE4_CHANNEL_TXPCSRESET_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_TXPCSRESET_TIME                (5'b00011),
  .GTHE4_CHANNEL_TXPCSRESET_VAL                 (1'b0),
  .GTHE4_CHANNEL_TXPDELECIDLEMODE_TIE_EN        (1'b0),
  .GTHE4_CHANNEL_TXPDELECIDLEMODE_VAL           (1'b0),
  .GTHE4_CHANNEL_TXPD_TIE_EN                    (1'b0),
  .GTHE4_CHANNEL_TXPD_VAL                       (2'b00),
  .GTHE4_CHANNEL_TXPHALIGNEN_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_TXPHALIGNEN_VAL                (1'b0),
  .GTHE4_CHANNEL_TXPHALIGN_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_TXPHALIGN_VAL                  (1'b0),
  .GTHE4_CHANNEL_TXPHDLYPD_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_TXPHDLYPD_VAL                  (1'b0),
  .GTHE4_CHANNEL_TXPHDLYRESET_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_TXPHDLYRESET_VAL               (1'b0),
  .GTHE4_CHANNEL_TXPHDLYTSTCLK_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_TXPHDLYTSTCLK_VAL              (1'b0),
  .GTHE4_CHANNEL_TXPHDLY_CFG0                   (16'b0110000001110000),
  .GTHE4_CHANNEL_TXPHDLY_CFG1                   (16'b0000000000001111),
  .GTHE4_CHANNEL_TXPHINIT_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_TXPHINIT_VAL                   (1'b0),
  .GTHE4_CHANNEL_TXPHOVRDEN_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_TXPHOVRDEN_VAL                 (1'b0),
  .GTHE4_CHANNEL_TXPH_CFG                       (16'b0000011100100011),
  .GTHE4_CHANNEL_TXPH_CFG2                      (16'b0000000000000000),
  .GTHE4_CHANNEL_TXPH_MONITOR_SEL               (5'b00000),
  .GTHE4_CHANNEL_TXPIPPMEN_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_TXPIPPMEN_VAL                  (1'b0),
  .GTHE4_CHANNEL_TXPIPPMOVRDEN_TIE_EN           (1'b0),
  .GTHE4_CHANNEL_TXPIPPMOVRDEN_VAL              (1'b0),
  .GTHE4_CHANNEL_TXPIPPMPD_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_TXPIPPMPD_VAL                  (1'b1),
  .GTHE4_CHANNEL_TXPIPPMSEL_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_TXPIPPMSEL_VAL                 (1'b0),
  .GTHE4_CHANNEL_TXPIPPMSTEPSIZE_TIE_EN         (1'b0),
  .GTHE4_CHANNEL_TXPIPPMSTEPSIZE_VAL            (5'b00000),
  .GTHE4_CHANNEL_TXPISOPD_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_TXPISOPD_VAL                   (1'b0),
  .GTHE4_CHANNEL_TXPI_CFG                       (16'b0000001111011111),
  .GTHE4_CHANNEL_TXPI_CFG0                      (2'b00),
  .GTHE4_CHANNEL_TXPI_CFG1                      (2'b00),
  .GTHE4_CHANNEL_TXPI_CFG2                      (2'b00),
  .GTHE4_CHANNEL_TXPI_CFG3                      (1'b1),
  .GTHE4_CHANNEL_TXPI_CFG4                      (1'b1),
  .GTHE4_CHANNEL_TXPI_CFG5                      (3'b000),
  .GTHE4_CHANNEL_TXPI_GRAY_SEL                  (1'b0),
  .GTHE4_CHANNEL_TXPI_INVSTROBE_SEL             (1'b0),
  .GTHE4_CHANNEL_TXPI_LPM                       (1'b0),
  .GTHE4_CHANNEL_TXPI_PPM                       (1'b0),
  .GTHE4_CHANNEL_TXPI_PPMCLK_SEL                ("TXUSRCLK2"),
  .GTHE4_CHANNEL_TXPI_PPM_CFG                   (8'b00000000),
  .GTHE4_CHANNEL_TXPI_SYNFREQ_PPM               (3'b001),
  .GTHE4_CHANNEL_TXPI_VREFSEL                   (1'b0),
  .GTHE4_CHANNEL_TXPLLCLKSEL_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_TXPLLCLKSEL_VAL                (2'b00),
  .GTHE4_CHANNEL_TXPMARESET_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_TXPMARESET_TIME                (5'b00011),
  .GTHE4_CHANNEL_TXPMARESET_VAL                 (1'b0),
  .GTHE4_CHANNEL_TXPOLARITY_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_TXPOLARITY_VAL                 (1'b0),
  .GTHE4_CHANNEL_TXPOSTCURSOR_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_TXPOSTCURSOR_VAL               (5'b00000),
  .GTHE4_CHANNEL_TXPRBSFORCEERR_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_TXPRBSFORCEERR_VAL             (1'b0),
  .GTHE4_CHANNEL_TXPRBSSEL_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_TXPRBSSEL_VAL                  (4'b0000),
  .GTHE4_CHANNEL_TXPRECURSOR_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_TXPRECURSOR_VAL                (5'b00000),
  .GTHE4_CHANNEL_TXPROGDIVRESET_TIE_EN          (1'b0),
  .GTHE4_CHANNEL_TXPROGDIVRESET_VAL             (1'b0),
  .GTHE4_CHANNEL_TXQPIBIASEN_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_TXQPIBIASEN_VAL                (1'b0),
  .GTHE4_CHANNEL_TXQPIWEAKPUP_TIE_EN            (1'b0),
  .GTHE4_CHANNEL_TXQPIWEAKPUP_VAL               (1'b0),
  .GTHE4_CHANNEL_TXRATEMODE_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_TXRATEMODE_VAL                 (1'b0),
  .GTHE4_CHANNEL_TXRATE_TIE_EN                  (1'b0),
  .GTHE4_CHANNEL_TXRATE_VAL                     (3'b000),
  .GTHE4_CHANNEL_TXREFCLKDIV2_SEL               (1'b0),
  .GTHE4_CHANNEL_TXSEQUENCE_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_TXSEQUENCE_VAL                 (7'b0000000),
  .GTHE4_CHANNEL_TXSWING_TIE_EN                 (1'b0),
  .GTHE4_CHANNEL_TXSWING_VAL                    (1'b0),
  .GTHE4_CHANNEL_TXSYNCALLIN_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_TXSYNCALLIN_VAL                (1'b0),
  .GTHE4_CHANNEL_TXSYNCIN_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_TXSYNCIN_VAL                   (1'b0),
  .GTHE4_CHANNEL_TXSYNCMODE_TIE_EN              (1'b0),
  .GTHE4_CHANNEL_TXSYNCMODE_VAL                 (1'b0),
  .GTHE4_CHANNEL_TXSYNC_MULTILANE               (1'b0),
  .GTHE4_CHANNEL_TXSYNC_OVRD                    (1'b0),
  .GTHE4_CHANNEL_TXSYNC_SKIP_DA                 (1'b0),
  .GTHE4_CHANNEL_TXSYSCLKSEL_TIE_EN             (1'b0),
  .GTHE4_CHANNEL_TXSYSCLKSEL_VAL                (2'b00),
  .GTHE4_CHANNEL_TXUSERRDY_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_TXUSERRDY_VAL                  (1'b1),
  .GTHE4_CHANNEL_TXUSRCLK2_TIE_EN               (1'b0),
  .GTHE4_CHANNEL_TXUSRCLK2_VAL                  (1'b0),
  .GTHE4_CHANNEL_TXUSRCLK_TIE_EN                (1'b0),
  .GTHE4_CHANNEL_TXUSRCLK_VAL                   (1'b0),
  .GTHE4_CHANNEL_TX_CLK25_DIV                   (5),
  .GTHE4_CHANNEL_TX_CLKMUX_EN                   (1'b1),
  .GTHE4_CHANNEL_TX_DATA_WIDTH                  (20),
  .GTHE4_CHANNEL_TX_DCC_LOOP_RST_CFG            (16'b0000000000000100),
  .GTHE4_CHANNEL_TX_DEEMPH0                     (6'b000000),
  .GTHE4_CHANNEL_TX_DEEMPH1                     (6'b000000),
  .GTHE4_CHANNEL_TX_DEEMPH2                     (6'b000000),
  .GTHE4_CHANNEL_TX_DEEMPH3                     (6'b000000),
  .GTHE4_CHANNEL_TX_DIVRESET_TIME               (5'b00001),
  .GTHE4_CHANNEL_TX_DRIVE_MODE                  ("DIRECT"),
  .GTHE4_CHANNEL_TX_DRVMUX_CTRL                 (2),
  .GTHE4_CHANNEL_TX_EIDLE_ASSERT_DELAY          (3'b100),
  .GTHE4_CHANNEL_TX_EIDLE_DEASSERT_DELAY        (3'b011),
  .GTHE4_CHANNEL_TX_FABINT_USRCLK_FLOP          (1'b0),
  .GTHE4_CHANNEL_TX_FIFO_BYP_EN                 (1'b1),
  .GTHE4_CHANNEL_TX_IDLE_DATA_ZERO              (1'b0),
  .GTHE4_CHANNEL_TX_INT_DATAWIDTH               (0),
  .GTHE4_CHANNEL_TX_LOOPBACK_DRIVE_HIZ          ("FALSE"),
  .GTHE4_CHANNEL_TX_MAINCURSOR_SEL              (1'b0),
  .GTHE4_CHANNEL_TX_MARGIN_FULL_0               (7'b1011111),
  .GTHE4_CHANNEL_TX_MARGIN_FULL_1               (7'b1011110),
  .GTHE4_CHANNEL_TX_MARGIN_FULL_2               (7'b1011100),
  .GTHE4_CHANNEL_TX_MARGIN_FULL_3               (7'b1011010),
  .GTHE4_CHANNEL_TX_MARGIN_FULL_4               (7'b1011000),
  .GTHE4_CHANNEL_TX_MARGIN_LOW_0                (7'b1000110),
  .GTHE4_CHANNEL_TX_MARGIN_LOW_1                (7'b1000101),
  .GTHE4_CHANNEL_TX_MARGIN_LOW_2                (7'b1000011),
  .GTHE4_CHANNEL_TX_MARGIN_LOW_3                (7'b1000010),
  .GTHE4_CHANNEL_TX_MARGIN_LOW_4                (7'b1000000),
  .GTHE4_CHANNEL_TX_PHICAL_CFG0                 (16'b0000000000000000),
  .GTHE4_CHANNEL_TX_PHICAL_CFG1                 (16'b0111111000000000),
  .GTHE4_CHANNEL_TX_PHICAL_CFG2                 (16'b0000001000000000),
  .GTHE4_CHANNEL_TX_PI_BIASSET                  (0),
  .GTHE4_CHANNEL_TX_PI_IBIAS_MID                (2'b00),
  .GTHE4_CHANNEL_TX_PMADATA_OPT                 (1'b0),
  .GTHE4_CHANNEL_TX_PMA_POWER_SAVE              (1'b0),
  .GTHE4_CHANNEL_TX_PMA_RSV0                    (16'b0000000000001000),
  .GTHE4_CHANNEL_TX_PREDRV_CTRL                 (2),
  .GTHE4_CHANNEL_TX_PROGCLK_SEL                 ("PREPI"),
  .GTHE4_CHANNEL_TX_PROGDIV_CFG                 (0.0),
  .GTHE4_CHANNEL_TX_PROGDIV_RATE                (16'b0000000000000001),
  .GTHE4_CHANNEL_TX_QPI_STATUS_EN               (1'b0),
  .GTHE4_CHANNEL_TX_RXDETECT_CFG                (14'b00000000110010),
  .GTHE4_CHANNEL_TX_RXDETECT_REF                (4),
  .GTHE4_CHANNEL_TX_SAMPLE_PERIOD               (3'b111),
  .GTHE4_CHANNEL_TX_SARC_LPBK_ENB               (1'b0),
  .GTHE4_CHANNEL_TX_SW_MEAS                     (2'b00),
  .GTHE4_CHANNEL_TX_VREG_CTRL                   (3'b000),
  .GTHE4_CHANNEL_TX_VREG_PDB                    (1'b0),
  .GTHE4_CHANNEL_TX_VREG_VREFSEL                (2'b00),
  .GTHE4_CHANNEL_TX_XCLK_SEL                    ("TXUSR"),
  .GTHE4_CHANNEL_USB_BOTH_BURST_IDLE            (1'b0),
  .GTHE4_CHANNEL_USB_BURSTMAX_U3WAKE            (7'b1111111),
  .GTHE4_CHANNEL_USB_BURSTMIN_U3WAKE            (7'b1100011),
  .GTHE4_CHANNEL_USB_CLK_COR_EQ_EN              (1'b0),
  .GTHE4_CHANNEL_USB_EXT_CNTL                   (1'b1),
  .GTHE4_CHANNEL_USB_IDLEMAX_POLLING            (10'b1010111011),
  .GTHE4_CHANNEL_USB_IDLEMIN_POLLING            (10'b0100101011),
  .GTHE4_CHANNEL_USB_LFPSPING_BURST             (9'b000000101),
  .GTHE4_CHANNEL_USB_LFPSPOLLING_BURST          (9'b000110001),
  .GTHE4_CHANNEL_USB_LFPSPOLLING_IDLE_MS        (9'b000000100),
  .GTHE4_CHANNEL_USB_LFPSU1EXIT_BURST           (9'b000011101),
  .GTHE4_CHANNEL_USB_LFPSU2LPEXIT_BURST_MS      (9'b001100011),
  .GTHE4_CHANNEL_USB_LFPSU3WAKE_BURST_MS        (9'b111110011),
  .GTHE4_CHANNEL_USB_LFPS_TPERIOD               (4'b0011),
  .GTHE4_CHANNEL_USB_LFPS_TPERIOD_ACCURATE      (1'b1),
  .GTHE4_CHANNEL_USB_MODE                       (1'b0),
  .GTHE4_CHANNEL_USB_PCIE_ERR_REP_DIS           (1'b0),
  .GTHE4_CHANNEL_USB_PING_SATA_MAX_INIT         (21),
  .GTHE4_CHANNEL_USB_PING_SATA_MIN_INIT         (12),
  .GTHE4_CHANNEL_USB_POLL_SATA_MAX_BURST        (8),
  .GTHE4_CHANNEL_USB_POLL_SATA_MIN_BURST        (4),
  .GTHE4_CHANNEL_USB_RAW_ELEC                   (1'b0),
  .GTHE4_CHANNEL_USB_RXIDLE_P0_CTRL             (1'b1),
  .GTHE4_CHANNEL_USB_TXIDLE_TUNE_ENABLE         (1'b1),
  .GTHE4_CHANNEL_USB_U1_SATA_MAX_WAKE           (7),
  .GTHE4_CHANNEL_USB_U1_SATA_MIN_WAKE           (4),
  .GTHE4_CHANNEL_USB_U2_SAS_MAX_COM             (64),
  .GTHE4_CHANNEL_USB_U2_SAS_MIN_COM             (36),
  .GTHE4_CHANNEL_USE_PCS_CLK_PHASE_SEL          (1'b0),
  .GTHE4_CHANNEL_Y_ALL_MODE                     (1'b0),
  .NUM_CHANNELS                                 (NUM_CHANNELS)
) channel_inst (

  // inputs
  .GTHE4_CHANNEL_CDRSTEPDIR                     (GTHE4_CHANNEL_CDRSTEPDIR),
  .GTHE4_CHANNEL_CDRSTEPSQ                      (GTHE4_CHANNEL_CDRSTEPSQ),
  .GTHE4_CHANNEL_CDRSTEPSX                      (GTHE4_CHANNEL_CDRSTEPSX),
  .GTHE4_CHANNEL_CFGRESET                       (GTHE4_CHANNEL_CFGRESET),
  .GTHE4_CHANNEL_CLKRSVD0                       (GTHE4_CHANNEL_CLKRSVD0),
  .GTHE4_CHANNEL_CLKRSVD1                       (GTHE4_CHANNEL_CLKRSVD1),
  .GTHE4_CHANNEL_CPLLFREQLOCK                   (GTHE4_CHANNEL_CPLLFREQLOCK),
  .GTHE4_CHANNEL_CPLLLOCKDETCLK                 (GTHE4_CHANNEL_CPLLLOCKDETCLK),
  .GTHE4_CHANNEL_CPLLLOCKEN                     (GTHE4_CHANNEL_CPLLLOCKEN),
  .GTHE4_CHANNEL_CPLLPD                         (GTHE4_CHANNEL_CPLLPD),
  .GTHE4_CHANNEL_CPLLREFCLKSEL                  (GTHE4_CHANNEL_CPLLREFCLKSEL),
  .GTHE4_CHANNEL_CPLLRESET                      (GTHE4_CHANNEL_CPLLRESET),
  .GTHE4_CHANNEL_DMONFIFORESET                  (GTHE4_CHANNEL_DMONFIFORESET),
  .GTHE4_CHANNEL_DMONITORCLK                    (GTHE4_CHANNEL_DMONITORCLK),
  .GTHE4_CHANNEL_DRPADDR                        (GTHE4_CHANNEL_DRPADDR),
  .GTHE4_CHANNEL_DRPCLK                         (GTHE4_CHANNEL_DRPCLK),
  .GTHE4_CHANNEL_DRPDI                          (GTHE4_CHANNEL_DRPDI),
  .GTHE4_CHANNEL_DRPEN                          (GTHE4_CHANNEL_DRPEN),
  .GTHE4_CHANNEL_DRPRST                         (GTHE4_CHANNEL_DRPRST),
  .GTHE4_CHANNEL_DRPWE                          (GTHE4_CHANNEL_DRPWE),
  .GTHE4_CHANNEL_EYESCANRESET                   (GTHE4_CHANNEL_EYESCANRESET),
  .GTHE4_CHANNEL_EYESCANTRIGGER                 (GTHE4_CHANNEL_EYESCANTRIGGER),
  .GTHE4_CHANNEL_FREQOS                         (GTHE4_CHANNEL_FREQOS),
  .GTHE4_CHANNEL_GTGREFCLK                      (GTHE4_CHANNEL_GTGREFCLK),
  .GTHE4_CHANNEL_GTHRXN                         (GTHE4_CHANNEL_GTHRXN),
  .GTHE4_CHANNEL_GTHRXP                         (GTHE4_CHANNEL_GTHRXP),
  .GTHE4_CHANNEL_GTNORTHREFCLK0                 (GTHE4_CHANNEL_GTNORTHREFCLK0),
  .GTHE4_CHANNEL_GTNORTHREFCLK1                 (GTHE4_CHANNEL_GTNORTHREFCLK1),
  .GTHE4_CHANNEL_GTREFCLK0                      (GTHE4_CHANNEL_GTREFCLK0),
  .GTHE4_CHANNEL_GTREFCLK1                      (GTHE4_CHANNEL_GTREFCLK1),
  .GTHE4_CHANNEL_GTRSVD                         (GTHE4_CHANNEL_GTRSVD),
  .GTHE4_CHANNEL_GTRXRESET                      (GTHE4_CHANNEL_GTRXRESET),
  .GTHE4_CHANNEL_GTRXRESETSEL                   (GTHE4_CHANNEL_GTRXRESETSEL),
  .GTHE4_CHANNEL_GTSOUTHREFCLK0                 (GTHE4_CHANNEL_GTSOUTHREFCLK0),
  .GTHE4_CHANNEL_GTSOUTHREFCLK1                 (GTHE4_CHANNEL_GTSOUTHREFCLK1),
  .GTHE4_CHANNEL_GTTXRESET                      (GTHE4_CHANNEL_GTTXRESET),
  .GTHE4_CHANNEL_GTTXRESETSEL                   (GTHE4_CHANNEL_GTTXRESETSEL),
  .GTHE4_CHANNEL_INCPCTRL                       (GTHE4_CHANNEL_INCPCTRL),
  .GTHE4_CHANNEL_LOOPBACK                       (GTHE4_CHANNEL_LOOPBACK),
  .GTHE4_CHANNEL_PCIEEQRXEQADAPTDONE            (GTHE4_CHANNEL_PCIEEQRXEQADAPTDONE),
  .GTHE4_CHANNEL_PCIERSTIDLE                    (GTHE4_CHANNEL_PCIERSTIDLE),
  .GTHE4_CHANNEL_PCIERSTTXSYNCSTART             (GTHE4_CHANNEL_PCIERSTTXSYNCSTART),
  .GTHE4_CHANNEL_PCIEUSERRATEDONE               (GTHE4_CHANNEL_PCIEUSERRATEDONE),
  .GTHE4_CHANNEL_PCSRSVDIN                      (GTHE4_CHANNEL_PCSRSVDIN),
  .GTHE4_CHANNEL_QPLL0CLK                       (GTHE4_CHANNEL_QPLL0CLK),
  .GTHE4_CHANNEL_QPLL0FREQLOCK                  (GTHE4_CHANNEL_QPLL0FREQLOCK),
  .GTHE4_CHANNEL_QPLL0REFCLK                    (GTHE4_CHANNEL_QPLL0REFCLK),
  .GTHE4_CHANNEL_QPLL1CLK                       (GTHE4_CHANNEL_QPLL1CLK),
  .GTHE4_CHANNEL_QPLL1FREQLOCK                  (GTHE4_CHANNEL_QPLL1FREQLOCK),
  .GTHE4_CHANNEL_QPLL1REFCLK                    (GTHE4_CHANNEL_QPLL1REFCLK),
  .GTHE4_CHANNEL_RESETOVRD                      (GTHE4_CHANNEL_RESETOVRD),
  .GTHE4_CHANNEL_RX8B10BEN                      (GTHE4_CHANNEL_RX8B10BEN),
  .GTHE4_CHANNEL_RXAFECFOKEN                    (GTHE4_CHANNEL_RXAFECFOKEN),
  .GTHE4_CHANNEL_RXBUFRESET                     (GTHE4_CHANNEL_RXBUFRESET),
  .GTHE4_CHANNEL_RXCDRFREQRESET                 (GTHE4_CHANNEL_RXCDRFREQRESET),
  .GTHE4_CHANNEL_RXCDRHOLD                      (GTHE4_CHANNEL_RXCDRHOLD),
  .GTHE4_CHANNEL_RXCDROVRDEN                    (GTHE4_CHANNEL_RXCDROVRDEN),
  .GTHE4_CHANNEL_RXCDRRESET                     (GTHE4_CHANNEL_RXCDRRESET),
  .GTHE4_CHANNEL_RXCHBONDEN                     (GTHE4_CHANNEL_RXCHBONDEN),
  .GTHE4_CHANNEL_RXCHBONDI                      (GTHE4_CHANNEL_RXCHBONDI),
  .GTHE4_CHANNEL_RXCHBONDLEVEL                  (GTHE4_CHANNEL_RXCHBONDLEVEL),
  .GTHE4_CHANNEL_RXCHBONDMASTER                 (GTHE4_CHANNEL_RXCHBONDMASTER),
  .GTHE4_CHANNEL_RXCHBONDSLAVE                  (GTHE4_CHANNEL_RXCHBONDSLAVE),
  .GTHE4_CHANNEL_RXCKCALRESET                   (GTHE4_CHANNEL_RXCKCALRESET),
  .GTHE4_CHANNEL_RXCKCALSTART                   (GTHE4_CHANNEL_RXCKCALSTART),
  .GTHE4_CHANNEL_RXCOMMADETEN                   (GTHE4_CHANNEL_RXCOMMADETEN),
  .GTHE4_CHANNEL_RXDFEAGCCTRL                   (GTHE4_CHANNEL_RXDFEAGCCTRL),
  .GTHE4_CHANNEL_RXDFEAGCHOLD                   (GTHE4_CHANNEL_RXDFEAGCHOLD),
  .GTHE4_CHANNEL_RXDFEAGCOVRDEN                 (GTHE4_CHANNEL_RXDFEAGCOVRDEN),
  .GTHE4_CHANNEL_RXDFECFOKFCNUM                 (GTHE4_CHANNEL_RXDFECFOKFCNUM),
  .GTHE4_CHANNEL_RXDFECFOKFEN                   (GTHE4_CHANNEL_RXDFECFOKFEN),
  .GTHE4_CHANNEL_RXDFECFOKFPULSE                (GTHE4_CHANNEL_RXDFECFOKFPULSE),
  .GTHE4_CHANNEL_RXDFECFOKHOLD                  (GTHE4_CHANNEL_RXDFECFOKHOLD),
  .GTHE4_CHANNEL_RXDFECFOKOVREN                 (GTHE4_CHANNEL_RXDFECFOKOVREN),
  .GTHE4_CHANNEL_RXDFEKHHOLD                    (GTHE4_CHANNEL_RXDFEKHHOLD),
  .GTHE4_CHANNEL_RXDFEKHOVRDEN                  (GTHE4_CHANNEL_RXDFEKHOVRDEN),
  .GTHE4_CHANNEL_RXDFELFHOLD                    (GTHE4_CHANNEL_RXDFELFHOLD),
  .GTHE4_CHANNEL_RXDFELFOVRDEN                  (GTHE4_CHANNEL_RXDFELFOVRDEN),
  .GTHE4_CHANNEL_RXDFELPMRESET                  (GTHE4_CHANNEL_RXDFELPMRESET),
  .GTHE4_CHANNEL_RXDFETAP10HOLD                 (GTHE4_CHANNEL_RXDFETAP10HOLD),
  .GTHE4_CHANNEL_RXDFETAP10OVRDEN               (GTHE4_CHANNEL_RXDFETAP10OVRDEN),
  .GTHE4_CHANNEL_RXDFETAP11HOLD                 (GTHE4_CHANNEL_RXDFETAP11HOLD),
  .GTHE4_CHANNEL_RXDFETAP11OVRDEN               (GTHE4_CHANNEL_RXDFETAP11OVRDEN),
  .GTHE4_CHANNEL_RXDFETAP12HOLD                 (GTHE4_CHANNEL_RXDFETAP12HOLD),
  .GTHE4_CHANNEL_RXDFETAP12OVRDEN               (GTHE4_CHANNEL_RXDFETAP12OVRDEN),
  .GTHE4_CHANNEL_RXDFETAP13HOLD                 (GTHE4_CHANNEL_RXDFETAP13HOLD),
  .GTHE4_CHANNEL_RXDFETAP13OVRDEN               (GTHE4_CHANNEL_RXDFETAP13OVRDEN),
  .GTHE4_CHANNEL_RXDFETAP14HOLD                 (GTHE4_CHANNEL_RXDFETAP14HOLD),
  .GTHE4_CHANNEL_RXDFETAP14OVRDEN               (GTHE4_CHANNEL_RXDFETAP14OVRDEN),
  .GTHE4_CHANNEL_RXDFETAP15HOLD                 (GTHE4_CHANNEL_RXDFETAP15HOLD),
  .GTHE4_CHANNEL_RXDFETAP15OVRDEN               (GTHE4_CHANNEL_RXDFETAP15OVRDEN),
  .GTHE4_CHANNEL_RXDFETAP2HOLD                  (GTHE4_CHANNEL_RXDFETAP2HOLD),
  .GTHE4_CHANNEL_RXDFETAP2OVRDEN                (GTHE4_CHANNEL_RXDFETAP2OVRDEN),
  .GTHE4_CHANNEL_RXDFETAP3HOLD                  (GTHE4_CHANNEL_RXDFETAP3HOLD),
  .GTHE4_CHANNEL_RXDFETAP3OVRDEN                (GTHE4_CHANNEL_RXDFETAP3OVRDEN),
  .GTHE4_CHANNEL_RXDFETAP4HOLD                  (GTHE4_CHANNEL_RXDFETAP4HOLD),
  .GTHE4_CHANNEL_RXDFETAP4OVRDEN                (GTHE4_CHANNEL_RXDFETAP4OVRDEN),
  .GTHE4_CHANNEL_RXDFETAP5HOLD                  (GTHE4_CHANNEL_RXDFETAP5HOLD),
  .GTHE4_CHANNEL_RXDFETAP5OVRDEN                (GTHE4_CHANNEL_RXDFETAP5OVRDEN),
  .GTHE4_CHANNEL_RXDFETAP6HOLD                  (GTHE4_CHANNEL_RXDFETAP6HOLD),
  .GTHE4_CHANNEL_RXDFETAP6OVRDEN                (GTHE4_CHANNEL_RXDFETAP6OVRDEN),
  .GTHE4_CHANNEL_RXDFETAP7HOLD                  (GTHE4_CHANNEL_RXDFETAP7HOLD),
  .GTHE4_CHANNEL_RXDFETAP7OVRDEN                (GTHE4_CHANNEL_RXDFETAP7OVRDEN),
  .GTHE4_CHANNEL_RXDFETAP8HOLD                  (GTHE4_CHANNEL_RXDFETAP8HOLD),
  .GTHE4_CHANNEL_RXDFETAP8OVRDEN                (GTHE4_CHANNEL_RXDFETAP8OVRDEN),
  .GTHE4_CHANNEL_RXDFETAP9HOLD                  (GTHE4_CHANNEL_RXDFETAP9HOLD),
  .GTHE4_CHANNEL_RXDFETAP9OVRDEN                (GTHE4_CHANNEL_RXDFETAP9OVRDEN),
  .GTHE4_CHANNEL_RXDFEUTHOLD                    (GTHE4_CHANNEL_RXDFEUTHOLD),
  .GTHE4_CHANNEL_RXDFEUTOVRDEN                  (GTHE4_CHANNEL_RXDFEUTOVRDEN),
  .GTHE4_CHANNEL_RXDFEVPHOLD                    (GTHE4_CHANNEL_RXDFEVPHOLD),
  .GTHE4_CHANNEL_RXDFEVPOVRDEN                  (GTHE4_CHANNEL_RXDFEVPOVRDEN),
  .GTHE4_CHANNEL_RXDFEXYDEN                     (GTHE4_CHANNEL_RXDFEXYDEN),
  .GTHE4_CHANNEL_RXDLYBYPASS                    (GTHE4_CHANNEL_RXDLYBYPASS),
  .GTHE4_CHANNEL_RXDLYEN                        (GTHE4_CHANNEL_RXDLYEN),
  .GTHE4_CHANNEL_RXDLYOVRDEN                    (GTHE4_CHANNEL_RXDLYOVRDEN),
  .GTHE4_CHANNEL_RXDLYSRESET                    (GTHE4_CHANNEL_RXDLYSRESET),
  .GTHE4_CHANNEL_RXELECIDLEMODE                 (GTHE4_CHANNEL_RXELECIDLEMODE),
  .GTHE4_CHANNEL_RXEQTRAINING                   (GTHE4_CHANNEL_RXEQTRAINING),
  .GTHE4_CHANNEL_RXGEARBOXSLIP                  (GTHE4_CHANNEL_RXGEARBOXSLIP),
  .GTHE4_CHANNEL_RXLATCLK                       (GTHE4_CHANNEL_RXLATCLK),
  .GTHE4_CHANNEL_RXLPMEN                        (GTHE4_CHANNEL_RXLPMEN),
  .GTHE4_CHANNEL_RXLPMGCHOLD                    (GTHE4_CHANNEL_RXLPMGCHOLD),
  .GTHE4_CHANNEL_RXLPMGCOVRDEN                  (GTHE4_CHANNEL_RXLPMGCOVRDEN),
  .GTHE4_CHANNEL_RXLPMHFHOLD                    (GTHE4_CHANNEL_RXLPMHFHOLD),
  .GTHE4_CHANNEL_RXLPMHFOVRDEN                  (GTHE4_CHANNEL_RXLPMHFOVRDEN),
  .GTHE4_CHANNEL_RXLPMLFHOLD                    (GTHE4_CHANNEL_RXLPMLFHOLD),
  .GTHE4_CHANNEL_RXLPMLFKLOVRDEN                (GTHE4_CHANNEL_RXLPMLFKLOVRDEN),
  .GTHE4_CHANNEL_RXLPMOSHOLD                    (GTHE4_CHANNEL_RXLPMOSHOLD),
  .GTHE4_CHANNEL_RXLPMOSOVRDEN                  (GTHE4_CHANNEL_RXLPMOSOVRDEN),
  .GTHE4_CHANNEL_RXMCOMMAALIGNEN                (GTHE4_CHANNEL_RXMCOMMAALIGNEN),
  .GTHE4_CHANNEL_RXMONITORSEL                   (GTHE4_CHANNEL_RXMONITORSEL),
  .GTHE4_CHANNEL_RXOOBRESET                     (GTHE4_CHANNEL_RXOOBRESET),
  .GTHE4_CHANNEL_RXOSCALRESET                   (GTHE4_CHANNEL_RXOSCALRESET),
  .GTHE4_CHANNEL_RXOSHOLD                       (GTHE4_CHANNEL_RXOSHOLD),
  .GTHE4_CHANNEL_RXOSOVRDEN                     (GTHE4_CHANNEL_RXOSOVRDEN),
  .GTHE4_CHANNEL_RXOUTCLKSEL                    (GTHE4_CHANNEL_RXOUTCLKSEL),
  .GTHE4_CHANNEL_RXPCOMMAALIGNEN                (GTHE4_CHANNEL_RXPCOMMAALIGNEN),
  .GTHE4_CHANNEL_RXPCSRESET                     (GTHE4_CHANNEL_RXPCSRESET),
  .GTHE4_CHANNEL_RXPD                           (GTHE4_CHANNEL_RXPD),
  .GTHE4_CHANNEL_RXPHALIGN                      (GTHE4_CHANNEL_RXPHALIGN),
  .GTHE4_CHANNEL_RXPHALIGNEN                    (GTHE4_CHANNEL_RXPHALIGNEN),
  .GTHE4_CHANNEL_RXPHDLYPD                      (GTHE4_CHANNEL_RXPHDLYPD),
  .GTHE4_CHANNEL_RXPHDLYRESET                   (GTHE4_CHANNEL_RXPHDLYRESET),
  .GTHE4_CHANNEL_RXPHOVRDEN                     (GTHE4_CHANNEL_RXPHOVRDEN),
  .GTHE4_CHANNEL_RXPLLCLKSEL                    (GTHE4_CHANNEL_RXPLLCLKSEL),
  .GTHE4_CHANNEL_RXPMARESET                     (GTHE4_CHANNEL_RXPMARESET),
  .GTHE4_CHANNEL_RXPOLARITY                     (GTHE4_CHANNEL_RXPOLARITY),
  .GTHE4_CHANNEL_RXPRBSCNTRESET                 (GTHE4_CHANNEL_RXPRBSCNTRESET),
  .GTHE4_CHANNEL_RXPRBSSEL                      (GTHE4_CHANNEL_RXPRBSSEL),
  .GTHE4_CHANNEL_RXPROGDIVRESET                 (GTHE4_CHANNEL_RXPROGDIVRESET),
  .GTHE4_CHANNEL_RXQPIEN                        (GTHE4_CHANNEL_RXQPIEN),
  .GTHE4_CHANNEL_RXRATE                         (GTHE4_CHANNEL_RXRATE),
  .GTHE4_CHANNEL_RXRATEMODE                     (GTHE4_CHANNEL_RXRATEMODE),
  .GTHE4_CHANNEL_RXSLIDE                        (GTHE4_CHANNEL_RXSLIDE),
  .GTHE4_CHANNEL_RXSLIPOUTCLK                   (GTHE4_CHANNEL_RXSLIPOUTCLK),
  .GTHE4_CHANNEL_RXSLIPPMA                      (GTHE4_CHANNEL_RXSLIPPMA),
  .GTHE4_CHANNEL_RXSYNCALLIN                    (GTHE4_CHANNEL_RXSYNCALLIN),
  .GTHE4_CHANNEL_RXSYNCIN                       (GTHE4_CHANNEL_RXSYNCIN),
  .GTHE4_CHANNEL_RXSYNCMODE                     (GTHE4_CHANNEL_RXSYNCMODE),
  .GTHE4_CHANNEL_RXSYSCLKSEL                    (GTHE4_CHANNEL_RXSYSCLKSEL),
  .GTHE4_CHANNEL_RXTERMINATION                  (GTHE4_CHANNEL_RXTERMINATION),
  .GTHE4_CHANNEL_RXUSERRDY                      (GTHE4_CHANNEL_RXUSERRDY),
  .GTHE4_CHANNEL_RXUSRCLK                       (GTHE4_CHANNEL_RXUSRCLK),
  .GTHE4_CHANNEL_RXUSRCLK2                      (GTHE4_CHANNEL_RXUSRCLK2),
  .GTHE4_CHANNEL_SIGVALIDCLK                    (GTHE4_CHANNEL_SIGVALIDCLK),
  .GTHE4_CHANNEL_TSTIN                          (GTHE4_CHANNEL_TSTIN),
  .GTHE4_CHANNEL_TX8B10BBYPASS                  (GTHE4_CHANNEL_TX8B10BBYPASS),
  .GTHE4_CHANNEL_TX8B10BEN                      (GTHE4_CHANNEL_TX8B10BEN),
  .GTHE4_CHANNEL_TXCOMINIT                      (GTHE4_CHANNEL_TXCOMINIT),
  .GTHE4_CHANNEL_TXCOMSAS                       (GTHE4_CHANNEL_TXCOMSAS),
  .GTHE4_CHANNEL_TXCOMWAKE                      (GTHE4_CHANNEL_TXCOMWAKE),
  .GTHE4_CHANNEL_TXCTRL0                        (GTHE4_CHANNEL_TXCTRL0),
  .GTHE4_CHANNEL_TXCTRL1                        (GTHE4_CHANNEL_TXCTRL1),
  .GTHE4_CHANNEL_TXCTRL2                        (GTHE4_CHANNEL_TXCTRL2),
  .GTHE4_CHANNEL_TXDATA                         (GTHE4_CHANNEL_TXDATA),
  .GTHE4_CHANNEL_TXDATAEXTENDRSVD               (GTHE4_CHANNEL_TXDATAEXTENDRSVD),
  .GTHE4_CHANNEL_TXDCCFORCESTART                (GTHE4_CHANNEL_TXDCCFORCESTART),
  .GTHE4_CHANNEL_TXDCCRESET                     (GTHE4_CHANNEL_TXDCCRESET),
  .GTHE4_CHANNEL_TXDEEMPH                       (GTHE4_CHANNEL_TXDEEMPH),
  .GTHE4_CHANNEL_TXDETECTRX                     (GTHE4_CHANNEL_TXDETECTRX),
  .GTHE4_CHANNEL_TXDIFFCTRL                     (GTHE4_CHANNEL_TXDIFFCTRL),
  .GTHE4_CHANNEL_TXDLYBYPASS                    (GTHE4_CHANNEL_TXDLYBYPASS),
  .GTHE4_CHANNEL_TXDLYEN                        (GTHE4_CHANNEL_TXDLYEN),
  .GTHE4_CHANNEL_TXDLYHOLD                      (GTHE4_CHANNEL_TXDLYHOLD),
  .GTHE4_CHANNEL_TXDLYOVRDEN                    (GTHE4_CHANNEL_TXDLYOVRDEN),
  .GTHE4_CHANNEL_TXDLYSRESET                    (GTHE4_CHANNEL_TXDLYSRESET),
  .GTHE4_CHANNEL_TXDLYUPDOWN                    (GTHE4_CHANNEL_TXDLYUPDOWN),
  .GTHE4_CHANNEL_TXELECIDLE                     (GTHE4_CHANNEL_TXELECIDLE),
  .GTHE4_CHANNEL_TXHEADER                       (GTHE4_CHANNEL_TXHEADER),
  .GTHE4_CHANNEL_TXINHIBIT                      (GTHE4_CHANNEL_TXINHIBIT),
  .GTHE4_CHANNEL_TXLATCLK                       (GTHE4_CHANNEL_TXLATCLK),
  .GTHE4_CHANNEL_TXLFPSTRESET                   (GTHE4_CHANNEL_TXLFPSTRESET),
  .GTHE4_CHANNEL_TXLFPSU2LPEXIT                 (GTHE4_CHANNEL_TXLFPSU2LPEXIT),
  .GTHE4_CHANNEL_TXLFPSU3WAKE                   (GTHE4_CHANNEL_TXLFPSU3WAKE),
  .GTHE4_CHANNEL_TXMAINCURSOR                   (GTHE4_CHANNEL_TXMAINCURSOR),
  .GTHE4_CHANNEL_TXMARGIN                       (GTHE4_CHANNEL_TXMARGIN),
  .GTHE4_CHANNEL_TXMUXDCDEXHOLD                 (GTHE4_CHANNEL_TXMUXDCDEXHOLD),
  .GTHE4_CHANNEL_TXMUXDCDORWREN                 (GTHE4_CHANNEL_TXMUXDCDORWREN),
  .GTHE4_CHANNEL_TXONESZEROS                    (GTHE4_CHANNEL_TXONESZEROS),
  .GTHE4_CHANNEL_TXOUTCLKSEL                    (GTHE4_CHANNEL_TXOUTCLKSEL),
  .GTHE4_CHANNEL_TXPCSRESET                     (GTHE4_CHANNEL_TXPCSRESET),
  .GTHE4_CHANNEL_TXPD                           (GTHE4_CHANNEL_TXPD),
  .GTHE4_CHANNEL_TXPDELECIDLEMODE               (GTHE4_CHANNEL_TXPDELECIDLEMODE),
  .GTHE4_CHANNEL_TXPHALIGN                      (GTHE4_CHANNEL_TXPHALIGN),
  .GTHE4_CHANNEL_TXPHALIGNEN                    (GTHE4_CHANNEL_TXPHALIGNEN),
  .GTHE4_CHANNEL_TXPHDLYPD                      (GTHE4_CHANNEL_TXPHDLYPD),
  .GTHE4_CHANNEL_TXPHDLYRESET                   (GTHE4_CHANNEL_TXPHDLYRESET),
  .GTHE4_CHANNEL_TXPHDLYTSTCLK                  (GTHE4_CHANNEL_TXPHDLYTSTCLK),
  .GTHE4_CHANNEL_TXPHINIT                       (GTHE4_CHANNEL_TXPHINIT),
  .GTHE4_CHANNEL_TXPHOVRDEN                     (GTHE4_CHANNEL_TXPHOVRDEN),
  .GTHE4_CHANNEL_TXPIPPMEN                      (GTHE4_CHANNEL_TXPIPPMEN),
  .GTHE4_CHANNEL_TXPIPPMOVRDEN                  (GTHE4_CHANNEL_TXPIPPMOVRDEN),
  .GTHE4_CHANNEL_TXPIPPMPD                      (GTHE4_CHANNEL_TXPIPPMPD),
  .GTHE4_CHANNEL_TXPIPPMSEL                     (GTHE4_CHANNEL_TXPIPPMSEL),
  .GTHE4_CHANNEL_TXPIPPMSTEPSIZE                (GTHE4_CHANNEL_TXPIPPMSTEPSIZE),
  .GTHE4_CHANNEL_TXPISOPD                       (GTHE4_CHANNEL_TXPISOPD),
  .GTHE4_CHANNEL_TXPLLCLKSEL                    (GTHE4_CHANNEL_TXPLLCLKSEL),
  .GTHE4_CHANNEL_TXPMARESET                     (GTHE4_CHANNEL_TXPMARESET),
  .GTHE4_CHANNEL_TXPOLARITY                     (GTHE4_CHANNEL_TXPOLARITY),
  .GTHE4_CHANNEL_TXPOSTCURSOR                   (GTHE4_CHANNEL_TXPOSTCURSOR),
  .GTHE4_CHANNEL_TXPRBSFORCEERR                 (GTHE4_CHANNEL_TXPRBSFORCEERR),
  .GTHE4_CHANNEL_TXPRBSSEL                      (GTHE4_CHANNEL_TXPRBSSEL),
  .GTHE4_CHANNEL_TXPRECURSOR                    (GTHE4_CHANNEL_TXPRECURSOR),
  .GTHE4_CHANNEL_TXPROGDIVRESET                 (GTHE4_CHANNEL_TXPROGDIVRESET),
  .GTHE4_CHANNEL_TXQPIBIASEN                    (GTHE4_CHANNEL_TXQPIBIASEN),
  .GTHE4_CHANNEL_TXQPIWEAKPUP                   (GTHE4_CHANNEL_TXQPIWEAKPUP),
  .GTHE4_CHANNEL_TXRATE                         (GTHE4_CHANNEL_TXRATE),
  .GTHE4_CHANNEL_TXRATEMODE                     (GTHE4_CHANNEL_TXRATEMODE),
  .GTHE4_CHANNEL_TXSEQUENCE                     (GTHE4_CHANNEL_TXSEQUENCE),
  .GTHE4_CHANNEL_TXSWING                        (GTHE4_CHANNEL_TXSWING),
  .GTHE4_CHANNEL_TXSYNCALLIN                    (GTHE4_CHANNEL_TXSYNCALLIN),
  .GTHE4_CHANNEL_TXSYNCIN                       (GTHE4_CHANNEL_TXSYNCIN),
  .GTHE4_CHANNEL_TXSYNCMODE                     (GTHE4_CHANNEL_TXSYNCMODE),
  .GTHE4_CHANNEL_TXSYSCLKSEL                    (GTHE4_CHANNEL_TXSYSCLKSEL),
  .GTHE4_CHANNEL_TXUSERRDY                      (GTHE4_CHANNEL_TXUSERRDY),
  .GTHE4_CHANNEL_TXUSRCLK                       (GTHE4_CHANNEL_TXUSRCLK),
  .GTHE4_CHANNEL_TXUSRCLK2                      (GTHE4_CHANNEL_TXUSRCLK2),

  // outputs
  .GTHE4_CHANNEL_BUFGTCE                        (GTHE4_CHANNEL_BUFGTCE),
  .GTHE4_CHANNEL_BUFGTCEMASK                    (GTHE4_CHANNEL_BUFGTCEMASK),
  .GTHE4_CHANNEL_BUFGTDIV                       (GTHE4_CHANNEL_BUFGTDIV),
  .GTHE4_CHANNEL_BUFGTRESET                     (GTHE4_CHANNEL_BUFGTRESET),
  .GTHE4_CHANNEL_BUFGTRSTMASK                   (GTHE4_CHANNEL_BUFGTRSTMASK),
  .GTHE4_CHANNEL_CPLLFBCLKLOST                  (GTHE4_CHANNEL_CPLLFBCLKLOST),
  .GTHE4_CHANNEL_CPLLLOCK                       (GTHE4_CHANNEL_CPLLLOCK),
  .GTHE4_CHANNEL_CPLLREFCLKLOST                 (GTHE4_CHANNEL_CPLLREFCLKLOST),
  .GTHE4_CHANNEL_DMONITOROUT                    (GTHE4_CHANNEL_DMONITOROUT),
  .GTHE4_CHANNEL_DMONITOROUTCLK                 (GTHE4_CHANNEL_DMONITOROUTCLK),
  .GTHE4_CHANNEL_DRPDO                          (GTHE4_CHANNEL_DRPDO),
  .GTHE4_CHANNEL_DRPRDY                         (GTHE4_CHANNEL_DRPRDY),
  .GTHE4_CHANNEL_EYESCANDATAERROR               (GTHE4_CHANNEL_EYESCANDATAERROR),
  .GTHE4_CHANNEL_GTHTXN                         (GTHE4_CHANNEL_GTHTXN),
  .GTHE4_CHANNEL_GTHTXP                         (GTHE4_CHANNEL_GTHTXP),
  .GTHE4_CHANNEL_GTPOWERGOOD                    (GTHE4_CHANNEL_GTPOWERGOOD),
  .GTHE4_CHANNEL_GTREFCLKMONITOR                (GTHE4_CHANNEL_GTREFCLKMONITOR),
  .GTHE4_CHANNEL_PCIERATEGEN3                   (GTHE4_CHANNEL_PCIERATEGEN3),
  .GTHE4_CHANNEL_PCIERATEIDLE                   (GTHE4_CHANNEL_PCIERATEIDLE),
  .GTHE4_CHANNEL_PCIERATEQPLLPD                 (GTHE4_CHANNEL_PCIERATEQPLLPD),
  .GTHE4_CHANNEL_PCIERATEQPLLRESET              (GTHE4_CHANNEL_PCIERATEQPLLRESET),
  .GTHE4_CHANNEL_PCIESYNCTXSYNCDONE             (GTHE4_CHANNEL_PCIESYNCTXSYNCDONE),
  .GTHE4_CHANNEL_PCIEUSERGEN3RDY                (GTHE4_CHANNEL_PCIEUSERGEN3RDY),
  .GTHE4_CHANNEL_PCIEUSERPHYSTATUSRST           (GTHE4_CHANNEL_PCIEUSERPHYSTATUSRST),
  .GTHE4_CHANNEL_PCIEUSERRATESTART              (GTHE4_CHANNEL_PCIEUSERRATESTART),
  .GTHE4_CHANNEL_PCSRSVDOUT                     (GTHE4_CHANNEL_PCSRSVDOUT),
  .GTHE4_CHANNEL_PHYSTATUS                      (GTHE4_CHANNEL_PHYSTATUS),
  .GTHE4_CHANNEL_PINRSRVDAS                     (GTHE4_CHANNEL_PINRSRVDAS),
  .GTHE4_CHANNEL_POWERPRESENT                   (GTHE4_CHANNEL_POWERPRESENT),
  .GTHE4_CHANNEL_RESETEXCEPTION                 (GTHE4_CHANNEL_RESETEXCEPTION),
  .GTHE4_CHANNEL_RXBUFSTATUS                    (GTHE4_CHANNEL_RXBUFSTATUS),
  .GTHE4_CHANNEL_RXBYTEISALIGNED                (GTHE4_CHANNEL_RXBYTEISALIGNED),
  .GTHE4_CHANNEL_RXBYTEREALIGN                  (GTHE4_CHANNEL_RXBYTEREALIGN),
  .GTHE4_CHANNEL_RXCDRLOCK                      (GTHE4_CHANNEL_RXCDRLOCK),
  .GTHE4_CHANNEL_RXCDRPHDONE                    (GTHE4_CHANNEL_RXCDRPHDONE),
  .GTHE4_CHANNEL_RXCHANBONDSEQ                  (GTHE4_CHANNEL_RXCHANBONDSEQ),
  .GTHE4_CHANNEL_RXCHANISALIGNED                (GTHE4_CHANNEL_RXCHANISALIGNED),
  .GTHE4_CHANNEL_RXCHANREALIGN                  (GTHE4_CHANNEL_RXCHANREALIGN),
  .GTHE4_CHANNEL_RXCHBONDO                      (GTHE4_CHANNEL_RXCHBONDO),
  .GTHE4_CHANNEL_RXCKCALDONE                    (GTHE4_CHANNEL_RXCKCALDONE),
  .GTHE4_CHANNEL_RXCLKCORCNT                    (GTHE4_CHANNEL_RXCLKCORCNT),
  .GTHE4_CHANNEL_RXCOMINITDET                   (GTHE4_CHANNEL_RXCOMINITDET),
  .GTHE4_CHANNEL_RXCOMMADET                     (GTHE4_CHANNEL_RXCOMMADET),
  .GTHE4_CHANNEL_RXCOMSASDET                    (GTHE4_CHANNEL_RXCOMSASDET),
  .GTHE4_CHANNEL_RXCOMWAKEDET                   (GTHE4_CHANNEL_RXCOMWAKEDET),
  .GTHE4_CHANNEL_RXCTRL0                        (GTHE4_CHANNEL_RXCTRL0),
  .GTHE4_CHANNEL_RXCTRL1                        (GTHE4_CHANNEL_RXCTRL1),
  .GTHE4_CHANNEL_RXCTRL2                        (GTHE4_CHANNEL_RXCTRL2),
  .GTHE4_CHANNEL_RXCTRL3                        (GTHE4_CHANNEL_RXCTRL3),
  .GTHE4_CHANNEL_RXDATA                         (GTHE4_CHANNEL_RXDATA),
  .GTHE4_CHANNEL_RXDATAEXTENDRSVD               (GTHE4_CHANNEL_RXDATAEXTENDRSVD),
  .GTHE4_CHANNEL_RXDATAVALID                    (GTHE4_CHANNEL_RXDATAVALID),
  .GTHE4_CHANNEL_RXDLYSRESETDONE                (GTHE4_CHANNEL_RXDLYSRESETDONE),
  .GTHE4_CHANNEL_RXELECIDLE                     (GTHE4_CHANNEL_RXELECIDLE),
  .GTHE4_CHANNEL_RXHEADER                       (GTHE4_CHANNEL_RXHEADER),
  .GTHE4_CHANNEL_RXHEADERVALID                  (GTHE4_CHANNEL_RXHEADERVALID),
  .GTHE4_CHANNEL_RXLFPSTRESETDET                (GTHE4_CHANNEL_RXLFPSTRESETDET),
  .GTHE4_CHANNEL_RXLFPSU2LPEXITDET              (GTHE4_CHANNEL_RXLFPSU2LPEXITDET),
  .GTHE4_CHANNEL_RXLFPSU3WAKEDET                (GTHE4_CHANNEL_RXLFPSU3WAKEDET),
  .GTHE4_CHANNEL_RXMONITOROUT                   (GTHE4_CHANNEL_RXMONITOROUT),
  .GTHE4_CHANNEL_RXOSINTDONE                    (GTHE4_CHANNEL_RXOSINTDONE),
  .GTHE4_CHANNEL_RXOSINTSTARTED                 (GTHE4_CHANNEL_RXOSINTSTARTED),
  .GTHE4_CHANNEL_RXOSINTSTROBEDONE              (GTHE4_CHANNEL_RXOSINTSTROBEDONE),
  .GTHE4_CHANNEL_RXOSINTSTROBESTARTED           (GTHE4_CHANNEL_RXOSINTSTROBESTARTED),
  .GTHE4_CHANNEL_RXOUTCLK                       (GTHE4_CHANNEL_RXOUTCLK),
  .GTHE4_CHANNEL_RXOUTCLKFABRIC                 (GTHE4_CHANNEL_RXOUTCLKFABRIC),
  .GTHE4_CHANNEL_RXOUTCLKPCS                    (GTHE4_CHANNEL_RXOUTCLKPCS),
  .GTHE4_CHANNEL_RXPHALIGNDONE                  (GTHE4_CHANNEL_RXPHALIGNDONE),
  .GTHE4_CHANNEL_RXPHALIGNERR                   (GTHE4_CHANNEL_RXPHALIGNERR),
  .GTHE4_CHANNEL_RXPMARESETDONE                 (GTHE4_CHANNEL_RXPMARESETDONE),
  .GTHE4_CHANNEL_RXPRBSERR                      (GTHE4_CHANNEL_RXPRBSERR),
  .GTHE4_CHANNEL_RXPRBSLOCKED                   (GTHE4_CHANNEL_RXPRBSLOCKED),
  .GTHE4_CHANNEL_RXPRGDIVRESETDONE              (GTHE4_CHANNEL_RXPRGDIVRESETDONE),
  .GTHE4_CHANNEL_RXQPISENN                      (GTHE4_CHANNEL_RXQPISENN),
  .GTHE4_CHANNEL_RXQPISENP                      (GTHE4_CHANNEL_RXQPISENP),
  .GTHE4_CHANNEL_RXRATEDONE                     (GTHE4_CHANNEL_RXRATEDONE),
  .GTHE4_CHANNEL_RXRECCLKOUT                    (GTHE4_CHANNEL_RXRECCLKOUT),
  .GTHE4_CHANNEL_RXRESETDONE                    (GTHE4_CHANNEL_RXRESETDONE),
  .GTHE4_CHANNEL_RXSLIDERDY                     (GTHE4_CHANNEL_RXSLIDERDY),
  .GTHE4_CHANNEL_RXSLIPDONE                     (GTHE4_CHANNEL_RXSLIPDONE),
  .GTHE4_CHANNEL_RXSLIPOUTCLKRDY                (GTHE4_CHANNEL_RXSLIPOUTCLKRDY),
  .GTHE4_CHANNEL_RXSLIPPMARDY                   (GTHE4_CHANNEL_RXSLIPPMARDY),
  .GTHE4_CHANNEL_RXSTARTOFSEQ                   (GTHE4_CHANNEL_RXSTARTOFSEQ),
  .GTHE4_CHANNEL_RXSTATUS                       (GTHE4_CHANNEL_RXSTATUS),
  .GTHE4_CHANNEL_RXSYNCDONE                     (GTHE4_CHANNEL_RXSYNCDONE),
  .GTHE4_CHANNEL_RXSYNCOUT                      (GTHE4_CHANNEL_RXSYNCOUT),
  .GTHE4_CHANNEL_RXVALID                        (GTHE4_CHANNEL_RXVALID),
  .GTHE4_CHANNEL_TXBUFSTATUS                    (GTHE4_CHANNEL_TXBUFSTATUS),
  .GTHE4_CHANNEL_TXCOMFINISH                    (GTHE4_CHANNEL_TXCOMFINISH),
  .GTHE4_CHANNEL_TXDCCDONE                      (GTHE4_CHANNEL_TXDCCDONE),
  .GTHE4_CHANNEL_TXDLYSRESETDONE                (GTHE4_CHANNEL_TXDLYSRESETDONE),
  .GTHE4_CHANNEL_TXOUTCLK                       (GTHE4_CHANNEL_TXOUTCLK),
  .GTHE4_CHANNEL_TXOUTCLKFABRIC                 (GTHE4_CHANNEL_TXOUTCLKFABRIC),
  .GTHE4_CHANNEL_TXOUTCLKPCS                    (GTHE4_CHANNEL_TXOUTCLKPCS),
  .GTHE4_CHANNEL_TXPHALIGNDONE                  (GTHE4_CHANNEL_TXPHALIGNDONE),
  .GTHE4_CHANNEL_TXPHINITDONE                   (GTHE4_CHANNEL_TXPHINITDONE),
  .GTHE4_CHANNEL_TXPMARESETDONE                 (GTHE4_CHANNEL_TXPMARESETDONE),
  .GTHE4_CHANNEL_TXPRGDIVRESETDONE              (GTHE4_CHANNEL_TXPRGDIVRESETDONE),
  .GTHE4_CHANNEL_TXQPISENN                      (GTHE4_CHANNEL_TXQPISENN),
  .GTHE4_CHANNEL_TXQPISENP                      (GTHE4_CHANNEL_TXQPISENP),
  .GTHE4_CHANNEL_TXRATEDONE                     (GTHE4_CHANNEL_TXRATEDONE),
  .GTHE4_CHANNEL_TXRESETDONE                    (GTHE4_CHANNEL_TXRESETDONE),
  .GTHE4_CHANNEL_TXSYNCDONE                     (GTHE4_CHANNEL_TXSYNCDONE),
  .GTHE4_CHANNEL_TXSYNCOUT                      (GTHE4_CHANNEL_TXSYNCOUT)
);

endmodule

